/* extmain.skel include file for extraction
 * $Log: extmain.skel,v $
 * Revision 1.19  1999/11/18 19:30:33  nort
 * Added <math.h> for floor() as generated for conversions
 *
 * Revision 1.18  1995/10/18  02:05:48  nort
 * Changes to nlcon_display()
 *
 * Revision 1.17  1995/10/06  16:40:02  nort
 * Changes to nlcon_disp()
 * Old change to ROWS() and FRACSECS() macros
 *
 * Revision 1.16  1994/08/29  20:29:28  nort
 * Changes for OUI
 *
 * Revision 1.15  1993/09/27  18:55:31  nort
 * Cleaned up RCS log
 * Cleaned up rcsid[] with Watcom pragmas
 * Added #include <string.h> for memcpy prototype.
 *
 * Revision 1.14  1993/05/19  19:04:51  nort
 * Changed OPT_CON_INIT to OPT_CONSOLE_INIT to allow judicious
 * redefinition for TMA.
 */
#include <stdio.h>
#include <string.h>
#include <sys/kernel.h>
#include <unistd.h>
#include <math.h>
#include "oui.h"
#include "dbr.h"
#include "globmsg.h"
#include "msg.h"
#pragma off (unreferenced)
  static char emrcsid[] =
	"$Id: extmain.skel,v 1.19 1999/11/18 19:30:33 nort Exp nort $";
#pragma on (unreferenced)



 typedef unsigned short UINT;


 typedef unsigned char UCHAR;
	unsigned short InjectingInc = 0;


 typedef unsigned long ULONG;
ULONG CHROMtime;
#include "convfunc.h"
#include "ttdriver.h"
#include "defcals.h"

int tt_p4=72;
int tt_p3=48;
int tt_p2=24;
int tt_p1=0;




	
	

	 typedef float adT;
	 typedef float adT_flow;
	 typedef float vdc_chan;
	 typedef float vdc_pow;
	 typedef float adT_pump;

	 typedef float dacMSpr;

	 typedef UINT InjStateT;

float read_atod(int atod_chan) {
	
	unsigned short atod_val;
	float voltage = -99999;

	atod_val = tt_read_atod( atod_chan );
	atod_val = atod_val + 2048;
	atod_val = atod_val & 0xFFF;

	if (atod_val >= 2048)	{
		atod_val = atod_val|(0xF000);
		atod_val=~atod_val;
		++atod_val;
		voltage = -10.0 * ((float) atod_val) / 2048.0;
		//	printf("reading atod channel %i value is negative %i \n",atod_chan, atod_val);
	} else 	{
		voltage = 10.0 * ((float) atod_val) / 2048.0;
	//	printf("reading atod channel %i value is %f \n",atod_chan,voltage);

	}	

	return voltage;
}


float read_temp(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps(voltage);
}


float read_temp12v(int address) { 
	float voltage;

	voltage = read_atod(address);

	return convert_temps12v(voltage);
}

float read_ad_value(int address, float R1, float V1, float V0) { 
	float Vx;

	Vx = read_atod(address);

	if (Vx < 0)
		Vx = -Vx;

	return convert_VtoR( Vx, R1, V1, V0 );

}



#include "valves.h"
#include "address.h"





	 typedef unsigned char DigOutWd;
	 typedef DigOutWd DigInWd;



	 typedef short DigBit;
	 typedef DigBit Bit_HI_LO;
	 typedef DigBit Bit_Op_Cl;
	 typedef DigBit Bit_Cl_Op;
	 typedef DigBit Bit_On_Off;
	 typedef DigBit Bit_Off_On;
	 typedef DigBit Bit_Air_Cal;
	 typedef DigBit Bit_offline;


	UCHAR MSDstateS;

int read_dig_in (unsigned short dig_chan)  {
	
	unsigned short dig_val;
	unsigned short address;
	int value;

	address=dig_chan/8;	
	dig_val=tt_read_digital(address);
	address=dig_chan-address*8;
	value=1<<address;
	//	address=pow(2,address);
	dig_val=dig_val&value;
	if (dig_val==0)
		return 0;
	return 1;
}

int read_dig_out(int chan) {

	return read_dig_in(chan+64);
}


int fail_board(int digch) {
	static int fail_toggle = 0;
	
	if (fail_toggle==0) {
		tt_scdc_command(100 + digch);
		fail_toggle = 1;
		return fail_toggle;
	}

	fail_toggle = 0;
	tt_scdc_command(digch);
	return fail_toggle;
}

// used to pulse a digch (hard coded for dig 20 and 21
// and MSDstate 4 and 5).
int trapToggle( int digch ) {
	static int pulse1 = 0;
	static int pulse2 = 0;
	int	pulse, state;
	const int trap1add = 20;
	const int trap2add = 21;

	if (digch == trap1add) {
	 	state = 4;
		pulse = pulse1;
	} else if (digch == trap2add) {
		state = 5;
		pulse = pulse2;
	} else {
		return 0;
	}

	// toggle dig line
	if ( MSDstateS == state ) {
		switch ( pulse ) {
			case 0:		// off, turn on
				tt_scdc_command( 100 + digch );
				pulse = 1;
				break;
			case 1:		// on, turn off
				tt_scdc_command( digch );
				pulse = 0;
				break;
		}
	} else {
		if ( pulse == 1 ) {
			tt_scdc_command( digch );
			pulse = 0;
		}
	}

	if (digch == trap1add)
		pulse1 = pulse;
	else
		pulse2 = pulse;

	return read_dig_out( digch );

}


#include <sys/types.h>
pid_t rs485_proxy;
short Omega485[34];

short OmegaArray( int add ) {
	return Omega485[add];
}



 typedef short OmegaT;

 typedef short OmegaTsp;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include "/home/panther/drivers/smart/smart.h"
#include "regnames.h"
#include "panthermsg.h"

#define 		ECDOFFLINE 		-9999
#define			NUMSECSXAXIS	 150
#define			ELECRATE		0.1			// seconds

pid_t			ECDresp_proxy;

chrom_packet 	ECDresp[MAXDET];

long int 		DetAvgCt1=0, DetAvgCt2=0, DetAvgCt3=0, DetAvgCt4=0,
		 		DetAvgOffline1=0, DetAvgOffline2=0, DetAvgOffline3=0, DetAvgOffline4=0,
	 			ecd_sum1=0, ecd_sum2=0, ecd_sum3=0, ecd_sum4=0,
				ecdA_SF6save=0, ecdA_F11save=0, ecdA_COsave=0, ecdA_PANsave=0;
float			ecdSF6x = 0.0, ecdF11x = 0.0, ecdCOx = 0.0, ecdPANx = 0.0;
int				currPoint[MAXDET];

// function gets the data from shared data array with smart driver
long int GC_Ctr_Pull( int elecADD ) {
	long ecdDATA;
	
	if ( currPoint[elecADD] >= MAXPOINTS ) currPoint[elecADD] = 0;

	// new data
	if ( currPoint[elecADD] < ECDresp[elecADD].numpnts ) {
		ecdDATA = ECDresp[elecADD].resp[currPoint[elecADD]];
		currPoint[elecADD]++;
	} 
	else {
		ecdDATA = ECDOFFLINE;
		currPoint[elecADD] = 0;
		ECDresp[elecADD].numpnts = -1;
	}

	return ecdDATA;	
}




 typedef long GC_Freq;
 typedef long GC_Ctr;

GC_Freq ecdA_SF6, ecdA_F11, ecdA_CO, ecdA_PAN;

 typedef unsigned char UNYBL;


 typedef unsigned long InjFile;

InjFile ITXFileNum;




ULONG CUMSEC;
#include <sys/types.h>
pid_t valco_proxy;
int valvePos[10] = {0,0,3,3,3,3,3,3,3,3};


 typedef short valvT;
 typedef DigBit valvetext;
 typedef DigBit valveMS1text;
 typedef DigBit valveMS2text;
#include <math.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "da_cache.h"
#include "regnames.h"

#define MAXMSDCHANS 	  8		// Max number of MS channels
#define MAXMSDIONS 		 30		// Max number of ions per channel
#define MAXMSDPOINTS 	 30		// Max Number of data points in a second for an ion
#define MSDOFFLINE 	  -9999
#define MSDMISSING	   -999
#define MAXSENDMSG     2000		// max number of chars from the msd server
#define SEPCHARS		":,()"
#define MSDIONFILE		"/home/panther/flight/msd.ions"

pid_t		MSDresp_proxy;

long int 	MSD_Data_Array[MAXMSDCHANS][MAXMSDPOINTS],
			MSD_Time_Array[MAXMSDPOINTS],
			msdTIMEoldPlot,
			MSchanAvg[MAXMSDCHANS],
			msd_sum[MAXMSDCHANS],
			MSD_ChanX;

unsigned int 	currMSDPoint[MAXMSDCHANS],
				chanInc;

unsigned char 	MSDresp[MAXSENDMSG];		// data returned by msd

struct MSwindow {
	float	ion;			// ion number
	float	dwell;			// dwell time (0 < dwell <= 1) (fraction of a second)
} MStable[MAXMSDCHANS][MAXMSDIONS];


int ReadMSDionFile ( char *IONFILE ) {
	FILE 	*fp;
	char 	buffer[1000];
	char 	*p;
	char	tmp[1];
	int		chan, inc;
	static char	once;
	double	ion, dwell;

	if (once == 1) return 0;

	fp = fopen(	IONFILE, "r" );
	if (fp == NULL) {
		fprintf(stderr, "Open failed: Cannont find %s\n", IONFILE);
		return -1;
	} else {
		while ( fgets( buffer, 1000, fp ) != NULL ) {

			// First strip out the MS channel number
			p = strstr( strlwr(buffer), "mschan" );
			strncpy(tmp, p + strlen("MSchan"), 1);
			chan = atoi(tmp);
			if (chan >= MAXMSDCHANS)
				break;
		
			// Next strip out the ions and dwell times
			p =	strtok(buffer, SEPCHARS );
			inc = 0;
			while ( p != NULL ) {

				if ( strstr(strlwr(p), "null") != NULL ) {
					MStable[chan][inc].ion = 0;
					MStable[chan][inc].dwell = 0;
					inc++;
				} else {
					ion = atof(p);
					if (ion >= 1) { 		// found ion
						p = strtok( NULL, SEPCHARS );
						dwell = atof(p);
						if (( dwell <= 1 ) && ( dwell > 0 )) {
							MStable[chan][inc].ion = ion;
							MStable[chan][inc].dwell = dwell;
							//printf ("%d,%d: %f %f\n", chan, inc, ion, dwell);
						} else {
							MStable[chan][inc].ion = 0;
							MStable[chan][inc].dwell = 0;
							fprintf(stderr, "Bad dwell time for channel %d, ion %f\n", chan, ion);
						}

						inc++;
					} else {
						MStable[chan][inc].ion = 0;
						MStable[chan][inc].dwell = 0;
						//printf("null ion: chan = %d, inc = %d\n", chan,inc);
					}

				}

				p = strtok( NULL, SEPCHARS );
			}
		}
	}

	fclose(fp);
	once = 1;

	return 0;

}

// Function takes a ion number and returns the MS channel number for
// a given time window.
int ion2chan( int win, float ion ) {

	int ch;
	float tol = 0.001;

	// Out of range variable
	if (win > MAXMSDIONS)
		return -1;

	// Scan MStable array for match
	for(ch=0; ch < MAXMSDCHANS; ch++) {
		if (((MStable[ch][win].ion - tol) < ion) && ((MStable[ch][win].ion + tol) > ion))
			return ch;
	}

	// No match in this time window
	return -1;

}

// Functions to pull data from MSD_Data and Time arrays.
long int MSD_Chan_Pull( int chan, int type ) {
	long msdDATA;
	static long msdTIMEold;

	if (currMSDPoint[chan] > MAXMSDPOINTS) 
		currMSDPoint[chan] = MAXMSDPOINTS;

	// type 0 is msd resp data, type 1 is msd time data.
	if ( type == 0 ) {
		msdDATA = MSD_Data_Array[chan][currMSDPoint[chan]];
		currMSDPoint[chan]++;
	} 
	else if ( type == 1 ) {		// real time displayed on text string.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEold;
		else
			msdTIMEold = msdDATA;
	}
	else if ( type == 2 ) {		// this time needs to be monitonically increasing for rtg.
		msdDATA = MSD_Time_Array[currMSDPoint[chan]-1];
		if ( msdDATA == MSDMISSING )
			msdDATA = msdTIMEoldPlot++;
		else if ( msdDATA <= msdTIMEoldPlot ) {
			if ( msdDATA > msdTIMEoldPlot )
				msdDATA = msdDATA + 10;	
			else
				msdDATA = msdTIMEoldPlot + 10;
		}
		msdTIMEoldPlot = msdDATA;
	}

	return msdDATA;	
}




 typedef unsigned short WinNum;

 typedef long MSD_DataType;

MSD_DataType msdA_0, msdA_1, msdA_2, msdA_3, msdA_4, msdA_5, msdA_6, msdA_7, msdA_8;

int MSD_load( unsigned short IonWinNum ) {

	char *p;
	unsigned int chaninc[MAXMSDCHANS], inc, i, c;
	int chan = 0;
	float ion;

	// Initialize global currMSDPoint to 0
	for(c=0; c < MAXMSDCHANS; c++) {
		chaninc[c] = 0;
		currMSDPoint[c] = 0;
	}

	// Fills in MSD_Data_Array with "missing" data MSDMISSING
	for(i=0; i < MAXMSDPOINTS; i++) {
		for(c=0; c < MAXMSDCHANS; c++) {
			MSD_Data_Array[c][i] = MSDMISSING;
			if (c == 0)
				MSD_Time_Array[i] = MSDMISSING;
		}
	}

	// Parse data returned in string MSDresp
	p = strtok(MSDresp, ",");
	inc = 0;
	while( p != NULL ) {

		// Get ion number
		if ( (inc % 3) == 0 ) {
			ion = atof(p);
			chan = ion2chan(IonWinNum, ion);
			// printf("ion = %f, chan = %d\n", ion, chan);
		} 

		// response data
		else if ( (inc % 3) == 1 ) {
			// Set data array
			if ((chan >= 0) && (chan < MAXMSDCHANS)) {
				MSD_Data_Array[chan][chaninc[chan]] = atol(p);
				chaninc[chan]++;
				if (chaninc[chan] > MAXMSDPOINTS) {
					chaninc[chan] = MAXMSDPOINTS;
					break;
				}
			}
		} 

		// time data
		else if ( (inc % 3) == 2 ) {
			if (chan == 0)
				MSD_Time_Array[chaninc[chan] - 1] = atol(p);
		} 

		p = strtok(NULL, ",");
		inc++;
	}

	// Set MSDresp array to 0
	for (i=0; i<MAXSENDMSG; i++) 
		MSDresp[i] = '\0';
	
	return 1;

}		



	unsigned short InjectingInc_MSD = 0;


ULONG MSDchromtime;
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include "regnames.h"

#define MAXMON 	19		// should match number in msd driver

pid_t	MSDeng_proxy;
float 	MSDeng[MAXMON];

void InitializeMSDeng() {
	int param;
	static char once;

	if (once == 1) return;

	for (param=0; param<MAXMON; param++)
		MSDeng[param] = -99.0;

	once = 1;

}




 typedef double MSDdouble;
#include <sys/types.h>
#include "maycomm.h"
pid_t maycomm_proxy = 0;

TDLstruct tdl;

#define USELONGPATH  900	// use the long path TDL when less than 900 ppm



 typedef float tdlfloat;
 typedef float tdlfloas;
 typedef short tdlint6;
  char * HI_LO_text[2] = { "LO", "HI" };
  char * Op_Cl_text[2] = { " Open", "Close" };
  char * Cl_Op_text[2] = { "Close", " Open" };
  char * Off_On_text[2] = { "Off", " On" };
  char * On_Off_text[2] = { " On", " Off" };
  char * Offline_text[2] = { "---", "---" };
  char * SrtSequence_off_text[2] = { "   Off", "SrtSeq" };
  char * Load_Inject_text[3] = { " Load ", "Inject" ,"ERROR " };
  char * Inject_Load_text[3] = { "Inject", " Load " ,"ERROR " };
  char * Inj1_Inj2_text[3] = { "Inj1 ", "Inj2 ", "ERROR" };
  char * Inj2_Inj1_text[3] = { "Inj2 ", "Inj1 ", "ERROR" };
  char * BF_IN_text[2] = { "IN", "BF" };
  char * IN_BF_text[2] = { "BF", "IN" };
  char * Heat_Cool_text[2] = { "Heat", "Cool" };
  char * GCstate_text[3] = { "No Injections", " Start Inject", "             " };
  char * Air_Cal_text[2] = { "air (off)", "cal (on) " };

  #include "rtgapi.h"
  rtg_t *chromSF6_rtg[2];
  int chromSF6_rtginc = 1;
  rtg_t *chromF11_rtg[2];
  int chromF11_rtginc = 1;
  rtg_t *chromCO_rtg[2];
  int chromCO_rtginc = 1;
  rtg_t *chromPAN_rtg[2];
  int chromPAN_rtginc = 1;
  rtg_t *ecdSF6prs_rtg[2];
  int ecdSF6prs_rtginc = 1;
  double Injection_rtgbt;
  #include "tmctime.h"
  rtg_t *ecdCOprs_rtg[2];
  int ecdCOprs_rtginc = 1;
  rtg_t *ecdPANprs_rtg[2];
  int ecdPANprs_rtginc = 1;
  rtg_t *ecdMSprs_rtg[2];
  int ecdMSprs_rtginc = 1;
  rtg_t *TDLshort_rtg[2];
  int TDLshort_rtginc = 1;
  rtg_t *TDLlong_rtg[2];
  int TDLlong_rtginc = 1;
  rtg_t *msdChan0_rtg[2];
  int msdChan0_rtginc = 1;
  rtg_t *msdChan1_rtg[2];
  int msdChan1_rtginc = 1;
  rtg_t *msdChan2_rtg[2];
  int msdChan2_rtginc = 1;
  rtg_t *msdChan3_rtg[2];
  int msdChan3_rtginc = 1;
  rtg_t *msdChan4_rtg[2];
  int msdChan4_rtginc = 1;
  rtg_t *msdChan5_rtg[2];
  int msdChan5_rtginc = 1;
  void rtgext_init( void ) {
    chromSF6_rtg[0] = rtg_init( "chromSF6/0" );
    chromSF6_rtg[1] = rtg_init( "chromSF6/1" );
    chromF11_rtg[0] = rtg_init( "chromF11/0" );
    chromF11_rtg[1] = rtg_init( "chromF11/1" );
    chromCO_rtg[0] = rtg_init( "chromCO/0" );
    chromCO_rtg[1] = rtg_init( "chromCO/1" );
    chromPAN_rtg[0] = rtg_init( "chromPAN/0" );
    chromPAN_rtg[1] = rtg_init( "chromPAN/1" );
    ecdSF6prs_rtg[0] = rtg_init( "ecdSF6prs/0" );
    ecdSF6prs_rtg[1] = rtg_init( "ecdSF6prs/1" );
    ecdCOprs_rtg[0] = rtg_init( "ecdCOprs/0" );
    ecdCOprs_rtg[1] = rtg_init( "ecdCOprs/1" );
    ecdPANprs_rtg[0] = rtg_init( "ecdPANprs/0" );
    ecdPANprs_rtg[1] = rtg_init( "ecdPANprs/1" );
    ecdMSprs_rtg[0] = rtg_init( "ecdMSprs/0" );
    ecdMSprs_rtg[1] = rtg_init( "ecdMSprs/1" );
    TDLshort_rtg[0] = rtg_init( "TDLshort/0" );
    TDLshort_rtg[1] = rtg_init( "TDLshort/1" );
    TDLlong_rtg[0] = rtg_init( "TDLlong/0" );
    TDLlong_rtg[1] = rtg_init( "TDLlong/1" );
    msdChan0_rtg[0] = rtg_init( "msdChan0/0" );
    msdChan0_rtg[1] = rtg_init( "msdChan0/1" );
    msdChan1_rtg[0] = rtg_init( "msdChan1/0" );
    msdChan1_rtg[1] = rtg_init( "msdChan1/1" );
    msdChan2_rtg[0] = rtg_init( "msdChan2/0" );
    msdChan2_rtg[1] = rtg_init( "msdChan2/1" );
    msdChan3_rtg[0] = rtg_init( "msdChan3/0" );
    msdChan3_rtg[1] = rtg_init( "msdChan3/1" );
    msdChan4_rtg[0] = rtg_init( "msdChan4/0" );
    msdChan4_rtg[1] = rtg_init( "msdChan4/1" );
    msdChan5_rtg[0] = rtg_init( "msdChan5/0" );
    msdChan5_rtg[1] = rtg_init( "msdChan5/1" );
  }

  #define N_CONSOLES 3

#ifdef CONSOLE_INIT
  #error CONSOLE_INIT is obsolete
#endif
#ifdef MSG_LABEL
  #error MSG_LABEL is obsolete
#endif

#ifdef N_CONSOLES
  #include "nl_cons.h"
  #ifndef DATA_ATTR
	#define DATA_ATTR 7
  #endif

  #define cdisplay(d,r,c,s) nlcon_display(d,r,c,s,DATA_ATTR)
  #define display_(d,r,c,t,v,s) {\
	static t sv_;\
	if (v != sv_) { cdisplay(d,r,c,s); sv_ = v; }\
  }
#endif


unsigned char V0 = 0x1;
unsigned char V1 = 0x1;
unsigned char V2 = 0x1;
unsigned char V3 = 0x1;
unsigned char V4 = 0x1;
unsigned char V5 = 0x1;
unsigned char V6 = 0x1;
unsigned char V7 = 0x1;
unsigned char V8 = 0x1;
unsigned char V9 = 0x3;
unsigned char V10 = 0x1;
unsigned char V11 = 0x1;
unsigned char V12 = 0x1;
unsigned char V13 = 0x1;
unsigned char V14 = 0x1;
unsigned char V15 = 0x3;
unsigned char V16 = 0x1;
unsigned char V17 = 0x3;
unsigned char V18 = 0x3;
unsigned char V19 = 0x7;
unsigned char V20 = 0x1;
unsigned char V21 = 0x1;
unsigned char V22 = 0x1;
unsigned char V23 = 0x1;
unsigned char V24 = 0x1;
unsigned char V25 = 0x1;
unsigned char V26 = 0x7;
unsigned char V27 = 0x7;
unsigned char V28 = 0x7;
unsigned char V29 = 0x7;
unsigned char V30 = 0x7;
unsigned char V31 = 0x7;
unsigned char V32 = 0x1;
unsigned char V33 = 0x3;
unsigned char V34 = 0x1;
unsigned char V35 = 0x1;
unsigned char V36 = 0x1;
unsigned char V37 = 0x7;
unsigned char V38 = 0x1;
unsigned char V39 = 0x7;
unsigned char V40 = 0x7;
unsigned char V41 = 0x7;
unsigned char V42 = 0x7;
unsigned char V43 = 0x7;
unsigned char V44 = 0x7;
unsigned char V45 = 0x7;
unsigned char V46 = 0x7;
unsigned char V47 = 0x7;
unsigned char V48 = 0x7;
unsigned char V49 = 0x7;
unsigned char V50 = 0x7;
unsigned char V51 = 0x7;
unsigned char V52 = 0x7;
unsigned char V53 = 0x7;
unsigned char V54 = 0x7;
unsigned char V55 = 0x7;
unsigned char V56 = 0x7;
unsigned char V57 = 0x7;
unsigned char V58 = 0x7;
unsigned char V59 = 0x7;
unsigned char V60 = 0x7;
unsigned char V61 = 0x7;
unsigned char V62 = 0x7;
unsigned char V63 = 0x7;
unsigned char V64 = 0x7;
unsigned char V65 = 0x7;
unsigned char V66 = 0x7;
unsigned char V67 = 0x7;
unsigned char V68 = 0x7;
unsigned char V69 = 0x7;
unsigned char V70 = 0x7;
unsigned char V71 = 0x7;
unsigned char V72 = 0x7;
unsigned char V73 = 0x1;
unsigned char V74 = 0x1;
unsigned char V75 = 0x7;
unsigned char V76 = 0x1;
unsigned char V77 = 0x7;
unsigned char V78 = 0x7;
unsigned char V79 = 0x7;
unsigned char V80 = 0x7;
unsigned char V81 = 0x7;
unsigned char V82 = 0x7;
unsigned char V83 = 0x7;
unsigned char V84 = 0x7;
unsigned char V85 = 0x1;
unsigned char V86 = 0x1;
unsigned char V87 = 0x1;
unsigned char V88 = 0x1;
unsigned char V89 = 0x1;
unsigned char V90 = 0x1;
unsigned char V91 = 0x1;
unsigned char V92 = 0x1;
unsigned char V93 = 0x1;
adT PresE_CO;
vdc_chan VoltBP_CO;
vdc_chan VoltE_SF6;
adT PresE_F11;
adT PresSrc_PAN;
adT PresBP_PAN;
vdc_chan VoltM_PAN;
vdc_chan VoltBP_PAN;
adT PresE_5;
vdc_chan VoltBP_5;
dacMSpr PresMS1sp;
dacMSpr PresMS2sp;
adT Trap1_set;
adT Trap1_re;
adT Trap2_set;
adT Trap2_re;
adT ColT_MS1;
adT ColT_MS2;
adT ColT_PAN;
adT Pres_SL;
adT Pres_Inlet;
adT Flow_MSsl;
adT Flow_Packsl;
adT Flow_PANsl;
adT PresH_CO2;
adT PresH_N2O;
adT PresH_ZA;
adT PresH_PAN;
adT PresH_Cal2;
adT PresH_Cal1;
adT PresH_He;
adT PresH_N2;
adT PresL_CO2;
adT PresL_N2O;
adT PresL_ZA;
adT PresL_PAN;
adT PresL_Cal2;
adT PresL_Cal1;
adT PresL_He;
adT PresL_N2;
adT Temp_F11sl;
adT Temp_COsl;
adT Temp_PANsl;
adT Temp_GSVbo;
adT Temp_elect;
adT Temp_stack;
adT Temp_GasBot;
adT Temp_PANlmp;
vdc_pow Pow_p28pri;
vdc_pow Pow_p28sec;
vdc_pow Pow_p15pel1;
vdc_pow Pow_p15pel2;
vdc_pow Pow_p12;
vdc_pow Pow_m15;
vdc_pow Pow_p15;
vdc_pow Pow_p5;
vdc_pow Pow_p24gsv;
vdc_pow Pow_p24ms;
MSDdouble msdREP;
MSDdouble msdAMUG;
MSDdouble msdIFOC;
MSDdouble msdFSEL;
MSDdouble msdENTO;
MSDdouble msdCAL;
MSDdouble msdSRCTEMP;
MSDdouble msdTURBOPCT;
MSDdouble msdMASO;
ULONG maycX;
tdlfloat tdllH2O;
tdlfloat tdlbH2O;
union {
  struct {
    UINT MFCtr;
    GC_Ctr GC_Ctr_CO;
    GC_Ctr GC_Ctr_F11;
    GC_Ctr GC_Ctr_PAN;
    GC_Ctr GC_Ctr_SF6;
    Bit_Off_On PANlamp;
    Bit_Off_On trap2heat;
    char U1[1];
    adT PresBP_CO;
    adT_flow FlowB_CO;
    adT_flow FlowM_CO;
    UINT Synch;
  } U0;
  struct {
    char U3[2];
    MSD_DataType MSD_TimePlot;
    MSD_DataType MSD_Time;
    MSD_DataType MSD_Chan5;
    MSD_DataType MSD_Chan4;
    Bit_Off_On trap1heat;
    Bit_Air_Cal PANsol1;
    char U4[2];
    UINT CurrFile;
    adT Pres2_PAN;
    char U5[1];
    adT_flow FlowM_SF6;
  } U2;
  struct {
    char U7[18];
    OmegaT SF6_Post;
    OmegaT F11_ECD;
    char U8[1];
    adT PresBP_F11;
    adT_flow FlowB_SF6;
    adT PresBP_SF6;
  } U6;
  struct {
    char U10[18];
    OmegaT Trap2_CB;
    OmegaT CO_ECD;
    char U11[1];
    adT PresBP_5;
    adT PresE_SF6;
    vdc_chan VoltM_SF6;
  } U9;
  struct {
    char U13[18];
    OmegaTsp F11_Col_Sp;
    OmegaTsp SF6_Post_Sp;
    char U14[2];
    vdc_chan VoltB_CO;
    UINT CurrInj;
    adT Pres1_PAN;
    UCHAR GCstate;
  } U12;
  struct {
    char U16[18];
    OmegaTsp CO_Col_Sp;
    OmegaTsp Trap2_CB_Sp;
    adT Temp_Ipump;
    adT Temp_PANsrc;
    adT Temp_SF6sl;
    UCHAR MSDstate;
  } U15;
  struct {
    char U18[18];
    valveMS2text valv_MS2;
    valveMS1text valv_MS1;
    Bit_HI_LO faildummy;
    vdc_chan VoltE_CO;
    vdc_chan VoltM_CO;
    char U19[3];
  } U17;
  struct {
    char U21[18];
    MSD_DataType MSD_Chan3;
    Bit_Cl_Op SLoopIN;
    vdc_chan VoltB_F11;
    char U22[2];
    Bit_Off_On pelt2State;
    char U23[3];
  } U20;
  struct {
    char U25[18];
    char U26[1];
    MSDdouble msdIPOL;
    vdc_chan VoltB_SF6;
    vdc_chan VoltBP_SF6;
  } U24;
  struct {
    char U28[18];
    char U29[2];
    MSDdouble msdEEGY;
    vdc_chan VoltM_F11;
    char U30[3];
  } U27;
  struct {
    char U32[18];
    char U33[3];
    MSDdouble msdAMUO;
    adT PresE_PAN;
    char U34[2];
  } U31;
  struct {
    char U36[18];
    char U37[4];
    Bit_Off_On trap2relay;
    char U38[2];
    Bit_Cl_Op SLoopOUT;
    vdc_chan VoltB_PAN;
    char U39[3];
  } U35;
  struct {
    char U41[18];
    char U42[5];
    MSDdouble msdMMW;
    adT_flow FlowM_F11;
  } U40;
  struct {
    char U44[18];
    char U45[6];
    char U46[1];
    adT_flow FlowSrc_PAN;
    char U47[6];
  } U43;
  struct {
    char U49[18];
    char U50[7];
    MSDdouble msdEMUL;
    char U51[2];
  } U48;
  struct {
    char U53[18];
    char U54[5];
    MSDdouble msdMASG;
    vdc_chan VoltBP_F11;
  } U52;
  struct {
    char U56[18];
    char U57[3];
    tdlfloat tdlsH2O;
    tdlfloas tdlT;
    tdlfloas tdlP;
    OmegaT CO_Col;
  } U55;
  struct {
    char U59[18];
    tdlint6  tdllZer;
    tdlint6  tdllPos;
    Bit_Cl_Op PANsol2;
    vdc_chan VoltE_PAN;
    vdc_chan VoltMS1;
    Bit_Cl_Op PANflsh;
    char U60[1];
  } U58;
  struct {
    char U62[22];
    OmegaTsp F11_ECD_Sp;
    vdc_chan VoltMS2;
    Bit_Off_On pelt1State;
    Bit_Off_On PANflowCont;
    Bit_HI_LO pilotTrip;
    char U63[1];
  } U61;
  struct {
    char U65[22];
    OmegaTsp CO_ECD_Sp;
    Bit_Op_Cl SLoopMSout;
    Bit_Op_Cl PANsol4;
    OmegaT Trap1_CB;
    OmegaT SF6_ECD;
    Bit_Off_On trap1relay;
    char U66[1];
  } U64;
  struct {
    char U68[22];
    valvetext valv_PAN;
    Bit_Off_On PANsol3;
    OmegaT SF6_Col;
    OmegaTsp SF6_Col_Sp;
    OmegaTsp Trap1_CB_Sp;
    OmegaT F11_Col;
    char U69[1];
  } U67;
  struct {
    char U71[22];
    MSD_DataType MSD_Chan2;
    OmegaT PAN_ECD;
    OmegaTsp PAN_ECD_Sp;
    valvT ssv2;
    OmegaTsp SF6_ECD_Sp;
    char U72[1];
  } U70;
  struct {
    char U74[22];
    MSDdouble msdENT;
    MSD_DataType MSD_Chan0;
    char U75[1];
  } U73;
  struct {
    char U77[22];
    char U78[4];
    valvetext valv_F11;
    valvetext valv_SF6;
    UINT CurrInj_MSD;
    valvT ssv1;
    char U79[1];
  } U76;
  struct {
    char U81[22];
    tdlint6  tdllPow;
    valvetext valv_CO;
    MSD_DataType MSD_Chan1;
    char U82[5];
  } U80;
  struct {
    char U84[24];
    WinNum IonWinNum;
    UINT CurrFile_MSD;
    char U85[7];
  } U83;
  struct {
    char U87[24];
    UINT loadMSDarray;
    MSDdouble msdQUAD;
    char U88[1];
  } U86;
  struct {
    char U90[24];
    MSDdouble msdHEDEN;
    char U91[3];
  } U89;
  struct {
    char U93[24];
    char U94[3];
    adT_flow FlowB_F11;
    adT PresMS1;
  } U92;
  struct {
    char U96[24];
    tdlint6  tdllAmp;
    ULONG maycX;
    tdlint6  tdlsPow;
    tdlint6  tdlsAmp;
    char U97[1];
  } U95;
  struct {
    char U99[26];
    tdlint6  tdlsZer;
    tdlint6  tdlsPos;
    tdlfloat tdlbH2O;
    char U100[1];
  } U98;
  struct {
    char U102[27];
    vdc_chan VoltE_F11;
    char U103[2];
    char U104[2];
  } U101;
  struct {
    char U106[27];
    adT PresMS2;
    char U107[4];
  } U105;
  struct {
    char U109[27];
    vdc_chan VoltE_5;
    char U110[4];
  } U108;
  struct {
    char U112[27];
    MSDdouble msdECUR;
  } U111;
  struct {
    char U114[34];
    char U115[1];
  } U113;
  struct {
    char U117[34];
    char U118[1];
  } U116;
  struct {
    char U120[34];
    char U121[1];
  } U119;
  struct {
    char U123[34];
    char U124[1];
  } U122;
  struct {
    char U126[34];
    char U127[1];
  } U125;
  struct {
    char U129[34];
    char U130[1];
  } U128;
  struct {
    char U132[34];
    char U133[1];
  } U131;
  struct {
    char U135[34];
    char U136[1];
  } U134;
  struct {
    char U138[34];
    char U139[1];
  } U137;
  struct {
    char U141[34];
    char U142[1];
  } U140;
  struct {
    char U144[34];
    char U145[1];
  } U143;
  struct {
    char U147[34];
    char U148[1];
  } U146;
  struct {
    char U150[34];
    char U151[1];
  } U149;
  struct {
    char U153[34];
    char U154[1];
  } U152;
  struct {
    char U156[34];
    char U157[1];
  } U155;
  struct {
    char U159[34];
    char U160[1];
  } U158;
  struct {
    char U162[34];
    char U163[1];
  } U161;
  struct {
    char U165[34];
    char U166[1];
  } U164;
  struct {
    char U168[34];
    char U169[1];
  } U167;
  struct {
    char U171[34];
    char U172[1];
  } U170;
  struct {
    char U174[34];
    char U175[1];
  } U173;
  struct {
    char U177[34];
    char U178[1];
  } U176;
  struct {
    char U180[34];
    char U181[1];
  } U179;
  struct {
    char U183[34];
    char U184[1];
  } U182;
  struct {
    char U186[34];
    char U187[1];
  } U185;
  struct {
    char U189[34];
    char U190[1];
  } U188;
  struct {
    char U192[34];
    char U193[1];
  } U191;
  struct {
    char U195[34];
    char U196[1];
  } U194;
  struct {
    char U198[34];
    char U199[1];
  } U197;
  struct {
    char U201[34];
    char U202[1];
  } U200;
  struct {
    char U204[34];
    char U205[1];
  } U203;
  struct {
    char U207[34];
    char U208[1];
  } U206;
  struct {
    char U210[34];
    char U211[1];
  } U209;
  struct {
    char U213[34];
    char U214[1];
  } U212;
  struct {
    char U216[34];
    char U217[1];
  } U215;
  struct {
    char U219[34];
    char U220[1];
  } U218;
  struct {
    char U222[34];
    char U223[1];
  } U221;
  struct {
    char U225[34];
    char U226[1];
  } U224;
  struct {
    char U228[34];
    char U229[1];
  } U227;
  struct {
    char U231[34];
    char U232[1];
  } U230;
  struct {
    char U234[34];
    char U235[1];
  } U233;
  struct {
    char U237[34];
    char U238[1];
  } U236;
  struct {
    char U240[34];
    char U241[1];
  } U239;
  struct {
    char U243[34];
    char U244[1];
  } U242;
  struct {
    char U246[34];
    char U247[1];
  } U245;
  struct {
    char U249[34];
    char U250[1];
  } U248;
  struct {
    char U252[34];
    char U253[1];
  } U251;
  struct {
    char U255[34];
    char U256[1];
  } U254;
  struct {
    char U258[34];
    char U259[1];
  } U257;
  struct {
    char U261[34];
    char U262[1];
  } U260;
  struct {
    char U264[34];
    char U265[1];
  } U263;
  struct {
    char U267[34];
    char U268[1];
  } U266;
  struct {
    char U270[34];
    char U271[1];
  } U269;
  struct {
    char U273[34];
    char U274[1];
  } U272;
  struct {
    char U276[34];
    char U277[1];
  } U275;
  struct {
    char U279[34];
    char U280[1];
  } U278;
  struct {
    char U282[34];
    char U283[1];
  } U281;
  struct {
    char U285[34];
    char U286[1];
  } U284;
  struct {
    char U288[34];
    char U289[1];
  } U287;
  struct {
    char U291[34];
    char U292[1];
  } U290;
  struct {
    char U294[34];
    char U295[1];
  } U293;
  struct {
    char U297[34];
    char U298[1];
  } U296;
  struct {
    char U300[34];
    char U301[1];
  } U299;
  struct {
    char U303[34];
    char U304[1];
  } U302;
  struct {
    char U306[34];
    char U307[1];
  } U305;
  struct {
    char U309[34];
    char U310[1];
  } U308;
  struct {
    char U312[34];
    char U313[1];
  } U311;
  struct {
    char U315[34];
    char U316[1];
  } U314;
  struct {
    char U318[34];
    char U319[1];
  } U317;
  struct {
    char U321[34];
    char U322[1];
  } U320;
  struct {
    char U324[34];
    char U325[1];
  } U323;
  struct {
    char U327[34];
    char U328[1];
  } U326;
  struct {
    char U330[34];
    char U331[1];
  } U329;
  struct {
    char U333[34];
    char U334[1];
  } U332;
  struct {
    char U336[34];
    char U337[1];
  } U335;
  struct {
    char U339[34];
    char U340[1];
  } U338;
  struct {
    char U342[34];
    char U343[1];
  } U341;
  struct {
    char U345[34];
    char U346[1];
  } U344;
  struct {
    char U348[34];
    char U349[1];
  } U347;
  struct {
    char U351[34];
    char U352[1];
  } U350;
  struct {
    char U354[34];
    char U355[1];
  } U353;
  struct {
    char U357[34];
    char U358[1];
  } U356;
  struct {
    char U360[34];
    char U361[1];
  } U359;
  struct {
    char U363[34];
    char U364[1];
  } U362;
  struct {
    char U366[34];
    char U367[1];
  } U365;
  struct {
    char U369[34];
    char U370[1];
  } U368;
  struct {
    char U372[34];
    char U373[1];
  } U371;
  struct {
    char U375[34];
    char U376[1];
  } U374;
  struct {
    char U378[34];
    char U379[1];
  } U377;
  struct {
    char U381[34];
    char U382[1];
  } U380;
  struct {
    char U384[34];
    char U385[1];
  } U383;
  struct {
    char U387[34];
    char U388[1];
  } U386;
  struct {
    char U390[34];
    char U391[1];
  } U389;
  struct {
    char U393[34];
    char U394[1];
  } U392;
  struct {
    char U396[34];
    char U397[1];
  } U395;
  struct {
    char U399[34];
    char U400[1];
  } U398;
  struct {
    char U402[34];
    char U403[1];
  } U401;
  struct {
    char U405[34];
    char U406[1];
  } U404;
  struct {
    char U408[34];
    char U409[1];
  } U407;
  struct {
    char U411[34];
    char U412[1];
  } U410;
  struct {
    char U414[34];
    char U415[1];
  } U413;
  struct {
    char U417[34];
    char U418[1];
  } U416;
  struct {
    char U420[34];
    char U421[1];
  } U419;
  struct {
    char U423[34];
    char U424[1];
  } U422;
  struct {
    char U426[34];
    char U427[1];
  } U425;
  struct {
    char U429[34];
    char U430[1];
  } U428;
  struct {
    char U432[34];
    char U433[1];
  } U431;
  struct {
    char U435[34];
    char U436[1];
  } U434;
  struct {
    char U438[34];
    char U439[1];
  } U437;
  struct {
    char U441[34];
    char U442[1];
  } U440;
  struct {
    char U444[34];
    char U445[1];
  } U443;
  struct {
    char U447[34];
    char U448[1];
  } U446;
  struct {
    char U450[34];
    char U451[1];
  } U449;
  struct {
    char U453[34];
    char U454[1];
  } U452;
  struct {
    char U456[34];
    char U457[1];
  } U455;
  struct {
    char U459[34];
    char U460[1];
  } U458;
  struct {
    char U462[34];
    char U463[1];
  } U461;
  struct {
    char U465[34];
    char U466[1];
  } U464;
  struct {
    char U468[34];
    char U469[1];
  } U467;
  struct {
    char U471[34];
    char U472[1];
  } U470;
  struct {
    char U474[34];
    char U475[1];
  } U473;
  struct {
    char U477[34];
    char U478[1];
  } U476;
  struct {
    char U480[34];
    char U481[1];
  } U479;
  struct {
    char U483[34];
    char U484[1];
  } U482;
  struct {
    char U486[34];
    char U487[1];
  } U485;
  struct {
    char U489[34];
    char U490[1];
  } U488;
  struct {
    char U492[34];
    char U493[1];
  } U491;
  struct {
    char U495[34];
    char U496[1];
  } U494;
  struct {
    char U498[34];
    char U499[1];
  } U497;
  struct {
    char U501[34];
    char U502[1];
  } U500;
  struct {
    char U504[34];
    char U505[1];
  } U503;
  struct {
    char U507[34];
    char U508[1];
  } U506;
  struct {
    char U510[34];
    char U511[1];
  } U509;
  struct {
    char U513[34];
    char U514[1];
  } U512;
  struct {
    char U516[34];
    char U517[1];
  } U515;
  struct {
    char U519[34];
    char U520[1];
  } U518;
  struct {
    char U522[34];
    char U523[1];
  } U521;
  struct {
    char U525[34];
    char U526[1];
  } U524;
  struct {
    char U528[34];
    char U529[1];
  } U527;
  struct {
    char U531[34];
    char U532[1];
  } U530;
  struct {
    char U534[34];
    char U535[1];
  } U533;
  struct {
    char U537[34];
    char U538[1];
  } U536;
  struct {
    char U540[34];
    char U541[1];
  } U539;
  struct {
    char U543[34];
    char U544[1];
  } U542;
  struct {
    char U546[34];
    char U547[1];
  } U545;
  struct {
    char U549[34];
    char U550[1];
  } U548;
  struct {
    char U552[34];
    char U553[1];
  } U551;
  struct {
    char U555[34];
    char U556[1];
  } U554;
  struct {
    char U558[34];
    char U559[1];
  } U557;
  struct {
    char U561[34];
    char U562[1];
  } U560;
  struct {
    char U564[34];
    char U565[1];
  } U563;
  struct {
    char U567[34];
    char U568[1];
  } U566;
  struct {
    char U570[34];
    char U571[1];
  } U569;
  struct {
    char U573[34];
    char U574[1];
  } U572;
  struct {
    char U576[34];
    char U577[1];
  } U575;
  struct {
    char U579[34];
    char U580[1];
  } U578;
  struct {
    char U582[34];
    char U583[1];
  } U581;
  struct {
    char U585[34];
    char U586[1];
  } U584;
  struct {
    char U588[34];
    char U589[1];
  } U587;
  struct {
    char U591[34];
    char U592[1];
  } U590;
  struct {
    char U594[34];
    char U595[1];
  } U593;
  struct {
    char U597[34];
    char U598[1];
  } U596;
  struct {
    char U600[34];
    char U601[1];
  } U599;
  struct {
    char U603[34];
    char U604[1];
  } U602;
  struct {
    char U606[34];
    char U607[1];
  } U605;
  struct {
    char U609[34];
    char U610[1];
  } U608;
  struct {
    char U612[34];
    char U613[1];
  } U611;
  struct {
    char U615[34];
    char U616[1];
  } U614;
  struct {
    char U618[34];
    char U619[1];
  } U617;
  struct {
    char U621[34];
    char U622[1];
  } U620;
  struct {
    char U624[34];
    char U625[1];
  } U623;
  struct {
    char U627[34];
    char U628[1];
  } U626;
  struct {
    char U630[34];
    char U631[1];
  } U629;
  struct {
    char U633[34];
    char U634[1];
  } U632;
  struct {
    char U636[34];
    char U637[1];
  } U635;
  struct {
    char U639[34];
    char U640[1];
  } U638;
  struct {
    char U642[34];
    char U643[1];
  } U641;
  struct {
    char U645[34];
    char U646[1];
  } U644;
  struct {
    char U648[34];
    char U649[1];
  } U647;
  struct {
    char U651[34];
    char U652[1];
  } U650;
  struct {
    char U654[34];
    char U655[1];
  } U653;
  struct {
    char U657[34];
    char U658[1];
  } U656;
  struct {
    char U660[34];
    char U661[1];
  } U659;
  struct {
    char U663[34];
    char U664[1];
  } U662;
  struct {
    char U666[34];
    char U667[1];
  } U665;
  struct {
    char U669[34];
    char U670[1];
  } U668;
  struct {
    char U672[34];
    char U673[1];
  } U671;
  struct {
    char U675[34];
    char U676[1];
  } U674;
  struct {
    char U678[34];
    char U679[1];
  } U677;
  struct {
    char U681[34];
    char U682[1];
  } U680;
  struct {
    char U684[34];
    char U685[1];
  } U683;
  struct {
    char U687[34];
    char U688[1];
  } U686;
  struct {
    char U690[34];
    char U691[1];
  } U689;
  struct {
    char U693[34];
    char U694[1];
  } U692;
  struct {
    char U696[34];
    char U697[1];
  } U695;
  struct {
    char U699[34];
    char U700[1];
  } U698;
  struct {
    char U702[34];
    char U703[1];
  } U701;
  struct {
    char U705[34];
    char U706[1];
  } U704;
  struct {
    char U708[34];
    char U709[1];
  } U707;
  struct {
    char U711[34];
    char U712[1];
  } U710;
  struct {
    char U714[34];
    char U715[1];
  } U713;
  struct {
    char U717[34];
    char U718[1];
  } U716;
  struct {
    char U720[34];
    char U721[1];
  } U719;
} *home;
char *SS_6_224_d_0( short int x) {
  static char obuf[7];
  int neg;

  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[4] = '-'; goto space3; }
    else goto space4;
  }
  obuf[4] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[3] = '-'; goto space2; }
    else goto space3;
  }
  obuf[3] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (x % 10) + '0';
  goto nospace;
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* doub icvt for tdlfloas -> tdlfloas */
double _CVT_0( tdlfloas x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
char *SL_6_1_f_4( long int x) {
  static char obuf[7];
  int neg;
  int iov;

  if (x < -9999 || x > 99999) return("******");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  iov = x/10;
  obuf[4] = '.';
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_1() int tcvt tdlfloas -> tdlfloas */
char *_CVT_1(tdlfloas x) {
  double iv;

  iv = _CVT_0( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for tdlfloat -> tdlfloat */
double _CVT_2( tdlfloat x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
char *SL_8_1_f_4( long int x) {
  static char obuf[9];
  int neg;
  int iov;

  if (x < -999999 || x > 9999999) return("********");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[8] = '\0';
  obuf[7] = (x % 10) + '0';
  x /= 10;
  obuf[6] = '.';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[4] = '-'; goto space3; }
    else goto space4;
  }
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) {
    if (neg) { obuf[3] = '-'; goto space2; }
    else goto space3;
  }
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_3() int tcvt tdlfloat -> tdlfloat */
char *_CVT_3(tdlfloat x) {
  double iv;

  iv = _CVT_2( x );
  if ( iv < -999999 || iv > 9999999 )
	return "********";
  return SL_8_1_f_4( iv );
}
/* doub icvt for MSDdouble -> MSDdouble */
double _CVT_4( MSDdouble x ) {
  return (double) floor(  x  * 1E3 + .5 );
}
char *SL_8_3_f_4( long int x) {
  static char obuf[9];
  int neg;
  int iov;

  if (x < -999999 || x > 9999999) return("********");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[8] = '\0';
  obuf[7] = (x % 10) + '0';
  x /= 10;
  obuf[6] = (x % 10) + '0';
  x /= 10;
  obuf[5] = (x % 10) + '0';
  iov = x/10;
  obuf[4] = '.';
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_5() int tcvt MSDdouble -> MSDdouble */
char *_CVT_5(MSDdouble x) {
  double iv;

  iv = _CVT_4( x );
  if ( iv < -999999 || iv > 9999999 )
	return "********";
  return SL_8_3_f_4( iv );
}
char *SL_9_224_d_8( long int x) {
  static char obuf[10];
  int neg;
  int iov;

  if (x < -99999999 || x > 999999999) return("*********");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[9] = '\0';
  obuf[8] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[7] = '-'; goto space6; }
    else goto space7;
  }
  obuf[7] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[6] = '-'; goto space5; }
    else goto space6;
  }
  obuf[6] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[5] = '-'; goto space4; }
    else goto space5;
  }
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[4] = '-'; goto space3; }
    else goto space4;
  }
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) {
    if (neg) { obuf[3] = '-'; goto space2; }
    else goto space3;
  }
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space7: obuf[7] = ' ';
  space6: obuf[6] = ' ';
  space5: obuf[5] = ' ';
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_6() int tcvt MSD_DataType -> MSD_DataType */
char *_CVT_6(MSD_DataType x) {
  if ( x < -99999999 || x > 999999999 )
	return "*********";
  return SL_9_224_d_8( x );
}
char *US_3_0_d_0( unsigned short int x) {
  static char obuf[4];

  if (x > 999) return("***");
  obuf[3] = '\0';
  obuf[2] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space1;
  obuf[1] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space0;
  obuf[0] = (x % 10) + '0';
  goto nospace;
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_7() int tcvt WinNum -> WinNum */
char *_CVT_7(WinNum x) {
  if ( x > 999 )
	return "***";
  return US_3_0_d_0( x );
}
char *US_3_224_u_0( unsigned short int x) {
  static char obuf[4];

  if (x > 999) return("***");
  obuf[3] = '\0';
  obuf[2] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space1;
  obuf[1] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space0;
  obuf[0] = (x % 10) + '0';
  goto nospace;
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_8() int tcvt valvT -> valvT */
char *_CVT_8(valvT x) {
  if ( x < 0 || x > 999 )
	return "***";
  return US_3_224_u_0( x );
}
char *SL_6_224_d_8( long int x) {
  static char obuf[7];
  int neg;
  int iov;

  if (x < -99999 || x > 999999) return("******");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[4] = '-'; goto space3; }
    else goto space4;
  }
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) {
    if (neg) { obuf[3] = '-'; goto space2; }
    else goto space3;
  }
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_9() int tcvt GC_Freq -> GC_Freq */
char *_CVT_9(GC_Freq x) {
  if ( x < -99999 || x > 999999 )
	return "******";
  return SL_6_224_d_8( x );
}
char *SS_6_1_f_4( short int x) {
  static char obuf[7];
  int neg;

  if (x < -9999) return("******");
  if (x < 0) { neg = 1; x = -x; }
  else neg = 0;
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  obuf[4] = '.';
  obuf[3] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[2] = '-'; goto space1; }
    else goto space2;
  }
  obuf[2] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[1] = '-'; goto space0; }
    else goto space1;
  }
  obuf[1] = (x % 10) + '0';
  x /= 10;
  if (x == 0) {
    if (neg) { obuf[0] = '-'; goto nospace; }
    else goto space0;
  }
  obuf[0] = (x % 10) + '0';
  goto nospace;
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_10() int tcvt OmegaTsp -> OmegaTsp */
char *_CVT_10(OmegaTsp x) {
  if ( x < -9999 )
	return "******";
  return SS_6_1_f_4( x );
}
/* _CVT_11() int tcvt OmegaT -> OmegaT */
char *_CVT_11(OmegaT x) {
  if ( x < -9999 )
	return "******";
  return SS_6_1_f_4( x );
}
/* doub icvt for dacMSpr -> dacMSpr */
double _CVT_12( dacMSpr x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_13() int tcvt dacMSpr -> dacMSpr */
char *_CVT_13(dacMSpr x) {
  double iv;

  iv = _CVT_12( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for vdc_pow -> vdc_pow */
double _CVT_14( vdc_pow x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_15() int tcvt vdc_pow -> vdc_pow */
char *_CVT_15(vdc_pow x) {
  double iv;

  iv = _CVT_14( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for vdc_chan -> vdc_chan */
double _CVT_16( vdc_chan x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_17() int tcvt vdc_chan -> vdc_chan */
char *_CVT_17(vdc_chan x) {
  double iv;

  iv = _CVT_16( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for adT_flow -> adT_flow */
double _CVT_18( adT_flow x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_19() int tcvt adT_flow -> adT_flow */
char *_CVT_19(adT_flow x) {
  double iv;

  iv = _CVT_18( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
/* doub icvt for adT -> adT */
double _CVT_20( adT x ) {
  return (double) floor(  x  * 1E1 + .5 );
}
/* _CVT_21() int tcvt adT -> adT */
char *_CVT_21(adT x) {
  double iv;

  iv = _CVT_20( x );
  if ( iv < -9999 || iv > 99999 )
	return "******";
  return SL_6_1_f_4( iv );
}
char *UL_6_0_u_0( unsigned long int x) {
  static char obuf[7];
  int iov;

  if (x > 999999) return("******");
  obuf[6] = '\0';
  obuf[5] = (x % 10) + '0';
  x /= 10;
  if (x == 0) goto space4;
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) goto space3;
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space2;
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space1;
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space0;
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space4: obuf[4] = ' ';
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}
/* _CVT_22() int tcvt ULONG -> ULONG */
char *_CVT_22(ULONG x) {
  if ( x > 999999 )
	return "******";
  return UL_6_0_u_0( x );
}
/* Text array for UCHAR -> UCHAR */
static char _CVT_23[256][4] = {
  "  0", "  1", "  2", "  3", "  4", "  5", "  6", "  7", "  8", "  9",
  " 10", " 11", " 12", " 13", " 14", " 15", " 16", " 17", " 18", " 19",
  " 20", " 21", " 22", " 23", " 24", " 25", " 26", " 27", " 28", " 29",
  " 30", " 31", " 32", " 33", " 34", " 35", " 36", " 37", " 38", " 39",
  " 40", " 41", " 42", " 43", " 44", " 45", " 46", " 47", " 48", " 49",
  " 50", " 51", " 52", " 53", " 54", " 55", " 56", " 57", " 58", " 59",
  " 60", " 61", " 62", " 63", " 64", " 65", " 66", " 67", " 68", " 69",
  " 70", " 71", " 72", " 73", " 74", " 75", " 76", " 77", " 78", " 79",
  " 80", " 81", " 82", " 83", " 84", " 85", " 86", " 87", " 88", " 89",
  " 90", " 91", " 92", " 93", " 94", " 95", " 96", " 97", " 98", " 99",
  "100", "101", "102", "103", "104", "105", "106", "107", "108", "109",
  "110", "111", "112", "113", "114", "115", "116", "117", "118", "119",
  "120", "121", "122", "123", "124", "125", "126", "127", "128", "129",
  "130", "131", "132", "133", "134", "135", "136", "137", "138", "139",
  "140", "141", "142", "143", "144", "145", "146", "147", "148", "149",
  "150", "151", "152", "153", "154", "155", "156", "157", "158", "159",
  "160", "161", "162", "163", "164", "165", "166", "167", "168", "169",
  "170", "171", "172", "173", "174", "175", "176", "177", "178", "179",
  "180", "181", "182", "183", "184", "185", "186", "187", "188", "189",
  "190", "191", "192", "193", "194", "195", "196", "197", "198", "199",
  "200", "201", "202", "203", "204", "205", "206", "207", "208", "209",
  "210", "211", "212", "213", "214", "215", "216", "217", "218", "219",
  "220", "221", "222", "223", "224", "225", "226", "227", "228", "229",
  "230", "231", "232", "233", "234", "235", "236", "237", "238", "239",
  "240", "241", "242", "243", "244", "245", "246", "247", "248", "249",
  "250", "251", "252", "253", "254", "255"
};
char *US_5_0_u_0( unsigned short int x) {
  static char obuf[6];
  int iov;

  obuf[5] = '\0';
  obuf[4] = (x % 10) + '0';
  iov = x/10;
  if (iov == 0) goto space3;
  obuf[3] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space2;
  obuf[2] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space1;
  obuf[1] = (iov % 10) + '0';
  iov /= 10;
  if (iov == 0) goto space0;
  obuf[0] = (iov % 10) + '0';
  goto nospace;
  space3: obuf[3] = ' ';
  space2: obuf[2] = ' ';
  space1: obuf[1] = ' ';
  space0: obuf[0] = ' ';
  nospace:
  return(obuf);
}

static void VSET_3_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* MaycommTog */
      V8 |= 0x1;
      break;
    case 1: /* MaycommInc */ {
        V19 |= 0x1;
        V18 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* MaycommTog */
      V8 &= ~0x1;
      break;
    case 1: /* MaycommInc */ {
        V19 &= ~0x1;
        V18 &= ~0x1;
        {
          rtg_increment( TDLshort_rtginc, 2 );
          rtg_increment( TDLlong_rtginc, 2 );
        }
      }
      break;
  }
}
static void VSET_2_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection_MSD */ {
        V25 |= 0x1;
        V24 |= 0x1;
        V23 |= 0x1;
        V22 |= 0x1;
        V21 |= 0x1;
        V20 |= 0x1;
        V6 |= 0x1;
      }
      break;
    case 2: /* Injecting_MSD */ {
        V7 |= 0x1;
        V5 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection_MSD */ {
        V25 &= ~0x1;
        V24 &= ~0x1;
        V23 &= ~0x1;
        V22 &= ~0x1;
        V21 &= ~0x1;
        V20 &= ~0x1;
        V6 &= ~0x1;
        {
          rtg_increment( msdChan0_rtginc, 2 );
          rtg_increment( msdChan1_rtginc, 2 );
          rtg_increment( msdChan2_rtginc, 2 );
          rtg_increment( msdChan3_rtginc, 2 );
          rtg_increment( msdChan4_rtginc, 2 );
          rtg_increment( msdChan5_rtginc, 2 );
        }
      }
      break;
    case 2: /* Injecting_MSD */ {
        V7 &= ~0x1;
        V5 &= ~0x1;
        {
        	msdTIMEoldPlot = 0;
        }
      }
      break;
    case 1: /* NotInjecting_MSD */ {
        {
        	ReadMSDionFile( MSDIONFILE );
        } {
        	InitializeMSDeng();
        }
      }
      break;
  }
}
static void VSET_1_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 2: /* GCTog */
      V3 |= 0x1;
      break;
    case 1: /* GCInc */ {
        V13 |= 0x1;
        V12 |= 0x1;
        V11 |= 0x1;
        V10 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 2: /* GCTog */
      V3 &= ~0x1;
      break;
    case 1: /* GCInc */ {
        V13 &= ~0x1;
        V12 &= ~0x1;
        V11 &= ~0x1;
        V10 &= ~0x1;
        {
          rtg_increment( chromSF6_rtginc, 2 );
          rtg_increment( chromF11_rtginc, 2 );
          rtg_increment( chromCO_rtginc, 2 );
          rtg_increment( chromPAN_rtginc, 2 );
        }
      }
      break;
  }
}
static void VSET_0_(unsigned short newstate) {
  static unsigned short oldstate;
  
  switch (oldstate) {
    case 3: /* Injection */ {
        V17 |= 0x1;
        V16 |= 0x1;
        V15 |= 0x1;
        V14 |= 0x1;
        V1 |= 0x1;
      }
      break;
    case 2: /* Injecting */ {
        V4 |= 0x1;
        V2 |= 0x1;
        V0 |= 0x1;
      }
      break;
  }
  oldstate = newstate;
  switch (newstate) {
    case 3: /* Injection */ {
        V17 &= ~0x1;
        V16 &= ~0x1;
        V15 &= ~0x1;
        V14 &= ~0x1;
        V1 &= ~0x1;
        {
          rtg_increment( ecdSF6prs_rtginc, 2 );
          rtg_increment( ecdCOprs_rtginc, 2 );
          rtg_increment( ecdPANprs_rtginc, 2 );
          rtg_increment( ecdMSprs_rtginc, 2 );
          Injection_rtgbt = dtime();
        }
      }
      break;
    case 2: /* Injecting */ {
        V4 &= ~0x1;
        V2 &= ~0x1;
        V0 &= ~0x1;
      }
      break;
  }
}
static void tminitfunc(void) {VSET_0_(1);VSET_1_(1);VSET_2_(1);VSET_3_(1);
  cdisplay(0,1,14,_CVT_22(0));
  cdisplay(0,1,32,US_5_0_u_0(0));
  cdisplay(0,2,14,_CVT_22(0));
  cdisplay(0,4,16,_CVT_21(0));
  cdisplay(0,5,16,_CVT_21(0));
  cdisplay(0,5,24,_CVT_17(0));
  cdisplay(0,5,42,_CVT_21(0));
  cdisplay(0,6,16,_CVT_21(0));
  cdisplay(0,6,24,_CVT_17(0));
  cdisplay(0,6,42,_CVT_21(0));
  cdisplay(0,8,10,_CVT_8(0));
  cdisplay(0,8,17,_CVT_8(0));
  cdisplay(0,8,26,Air_Cal_text[0]);
  cdisplay(0,9,29,Off_On_text[0]);
  cdisplay(0,9,35,Off_On_text[0]);
  cdisplay(0,9,41,Off_On_text[0]);
  cdisplay(0,10,25,_CVT_19(0));
  cdisplay(0,10,32,_CVT_21(0));
  cdisplay(0,1,62,HI_LO_text[0]);
  cdisplay(0,2,62,HI_LO_text[0]);
  cdisplay(0,5,56,Cl_Op_text[0]);
  cdisplay(0,5,62,Cl_Op_text[0]);
  cdisplay(0,6,56,Cl_Op_text[0]);
  cdisplay(0,6,62,Op_Cl_text[0]);
  cdisplay(0,7,63,Cl_Op_text[0]);
  cdisplay(0,12,25,Load_Inject_text[0]);
  cdisplay(0,13,7,_CVT_9(0));
  cdisplay(0,14,7,_CVT_11(0));
  cdisplay(0,14,20,_CVT_10(0));
  cdisplay(0,15,7,_CVT_11(0));
  cdisplay(0,15,20,_CVT_10(0));
  cdisplay(0,16,7,_CVT_11(0));
  cdisplay(0,16,20,_CVT_10(0));
  cdisplay(0,17,7,_CVT_19(0));
  cdisplay(0,17,20,_CVT_17(0));
  cdisplay(0,18,7,_CVT_19(0));
  cdisplay(0,18,20,_CVT_17(0));
  cdisplay(0,19,7,_CVT_21(0));
  cdisplay(0,19,20,_CVT_17(0));
  cdisplay(0,20,7,_CVT_21(0));
  cdisplay(0,20,20,_CVT_17(0));
  cdisplay(0,12,59,Load_Inject_text[0]);
  cdisplay(0,13,42,_CVT_9(0));
  cdisplay(0,14,42,_CVT_11(0));
  cdisplay(0,14,55,_CVT_10(0));
  cdisplay(0,15,42,_CVT_11(0));
  cdisplay(0,15,55,_CVT_10(0));
  cdisplay(0,16,42,_CVT_19(0));
  cdisplay(0,16,55,_CVT_17(0));
  cdisplay(0,17,42,_CVT_19(0));
  cdisplay(0,17,55,_CVT_17(0));
  cdisplay(0,18,42,_CVT_21(0));
  cdisplay(0,18,55,_CVT_17(0));
  cdisplay(0,19,42,_CVT_21(0));
  cdisplay(0,19,55,_CVT_17(0));
  cdisplay(0,22,24,Load_Inject_text[0]);
  cdisplay(0,23,7,_CVT_9(0));
  cdisplay(0,24,7,_CVT_11(0));
  cdisplay(0,24,20,_CVT_10(0));
  cdisplay(0,25,7,_CVT_11(0));
  cdisplay(0,25,20,_CVT_10(0));
  cdisplay(0,26,7,_CVT_19(0));
  cdisplay(0,26,20,_CVT_17(0));
  cdisplay(0,27,7,_CVT_19(0));
  cdisplay(0,27,20,_CVT_17(0));
  cdisplay(0,28,7,_CVT_21(0));
  cdisplay(0,28,20,_CVT_17(0));
  cdisplay(0,29,7,_CVT_21(0));
  cdisplay(0,29,20,_CVT_17(0));
  cdisplay(0,22,59,Load_Inject_text[0]);
  cdisplay(0,23,42,_CVT_9(0));
  cdisplay(0,24,42,_CVT_11(0));
  cdisplay(0,24,55,_CVT_10(0));
  cdisplay(0,25,42,_CVT_21(0));
  cdisplay(0,26,42,_CVT_21(0));
  cdisplay(0,26,55,_CVT_17(0));
  cdisplay(0,27,42,_CVT_21(0));
  cdisplay(0,27,55,_CVT_17(0));
  cdisplay(0,28,42,_CVT_21(0));
  cdisplay(0,28,55,_CVT_17(0));
  cdisplay(1,3,18,_CVT_21(0));
  cdisplay(1,4,18,_CVT_21(0));
  cdisplay(1,5,18,_CVT_21(0));
  cdisplay(1,6,18,_CVT_21(0));
  cdisplay(1,7,18,_CVT_21(0));
  cdisplay(1,8,18,_CVT_21(0));
  cdisplay(1,9,18,_CVT_21(0));
  cdisplay(1,10,18,_CVT_21(0));
  cdisplay(1,11,18,_CVT_21(0));
  cdisplay(1,12,18,_CVT_21(0));
  cdisplay(1,13,18,_CVT_21(0));
  cdisplay(1,3,42,_CVT_15(0));
  cdisplay(1,4,42,_CVT_15(0));
  cdisplay(1,5,42,_CVT_15(0));
  cdisplay(1,6,42,_CVT_15(0));
  cdisplay(1,7,42,_CVT_15(0));
  cdisplay(1,8,42,_CVT_15(0));
  cdisplay(1,9,42,_CVT_15(0));
  cdisplay(1,10,42,_CVT_15(0));
  cdisplay(1,11,42,_CVT_15(0));
  cdisplay(1,12,42,_CVT_15(0));
  cdisplay(1,4,56,_CVT_21(0));
  cdisplay(1,4,64,_CVT_21(0));
  cdisplay(1,5,56,_CVT_21(0));
  cdisplay(1,5,64,_CVT_21(0));
  cdisplay(1,6,56,_CVT_21(0));
  cdisplay(1,6,64,_CVT_21(0));
  cdisplay(1,7,56,_CVT_21(0));
  cdisplay(1,7,64,_CVT_21(0));
  cdisplay(1,8,56,_CVT_21(0));
  cdisplay(1,8,64,_CVT_21(0));
  cdisplay(1,9,56,_CVT_21(0));
  cdisplay(1,9,64,_CVT_21(0));
  cdisplay(1,10,56,_CVT_21(0));
  cdisplay(1,10,64,_CVT_21(0));
  cdisplay(1,11,56,_CVT_21(0));
  cdisplay(1,11,64,_CVT_21(0));
  cdisplay(1,16,12,_CVT_11(0));
  cdisplay(1,16,20,_CVT_10(0));
  cdisplay(1,16,33,_CVT_11(0));
  cdisplay(1,16,41,_CVT_10(0));
  cdisplay(1,16,54,_CVT_11(0));
  cdisplay(1,16,62,_CVT_10(0));
  cdisplay(1,17,12,_CVT_11(0));
  cdisplay(1,17,20,_CVT_10(0));
  cdisplay(1,17,33,_CVT_11(0));
  cdisplay(1,17,41,_CVT_10(0));
  cdisplay(1,18,12,_CVT_11(0));
  cdisplay(1,18,20,_CVT_10(0));
  cdisplay(1,18,33,_CVT_11(0));
  cdisplay(1,18,41,_CVT_10(0));
  cdisplay(1,19,12,_CVT_11(0));
  cdisplay(1,19,20,_CVT_10(0));
  cdisplay(1,20,18,_CVT_11(0));
  cdisplay(1,20,26,_CVT_10(0));
  cdisplay(1,20,38,_CVT_11(0));
  cdisplay(1,20,46,_CVT_10(0));
  cdisplay(1,23,11,_CVT_1(0));
  cdisplay(1,24,11,_CVT_1(0));
  cdisplay(1,27,11,_CVT_3(0));
  cdisplay(1,23,36,_CVT_3(0));
  cdisplay(1,24,38,SS_6_224_d_0(0));
  cdisplay(1,25,38,SS_6_224_d_0(0));
  cdisplay(1,26,38,SS_6_224_d_0(0));
  cdisplay(1,27,38,SS_6_224_d_0(0));
  cdisplay(1,23,58,_CVT_3(0));
  cdisplay(1,24,60,SS_6_224_d_0(0));
  cdisplay(1,25,60,SS_6_224_d_0(0));
  cdisplay(1,26,60,SS_6_224_d_0(0));
  cdisplay(1,27,60,SS_6_224_d_0(0));
  cdisplay(2,3,10,_CVT_6(0));
  cdisplay(2,3,30,_CVT_6(0));
  cdisplay(2,4,10,_CVT_6(0));
  cdisplay(2,4,30,_CVT_6(0));
  cdisplay(2,5,10,_CVT_6(0));
  cdisplay(2,6,10,_CVT_6(0));
  cdisplay(2,7,12,_CVT_6(0));
  cdisplay(2,10,14,_CVT_22(0));
  cdisplay(2,10,35,US_5_0_u_0(0));
  cdisplay(2,11,14,_CVT_22(0));
  cdisplay(2,11,37,_CVT_7(0));
  cdisplay(2,14,11,_CVT_8(0));
  cdisplay(2,14,29,_CVT_8(0));
  cdisplay(2,15,12,_CVT_23[0]);
  cdisplay(2,16,11,Inj2_Inj1_text[0]);
  cdisplay(2,16,29,Inj2_Inj1_text[0]);
  cdisplay(2,19,8,_CVT_21(0));
  cdisplay(2,19,21,_CVT_17(0));
  cdisplay(2,20,8,_CVT_21(0));
  cdisplay(2,21,16,Op_Cl_text[0]);
  cdisplay(2,23,12,_CVT_21(0));
  cdisplay(2,23,24,_CVT_17(0));
  cdisplay(2,26,20,_CVT_21(0));
  cdisplay(2,26,33,_CVT_17(0));
  cdisplay(2,27,20,_CVT_13(0));
  cdisplay(2,28,20,_CVT_21(0));
  cdisplay(2,29,20,_CVT_21(0));
  cdisplay(2,29,33,_CVT_17(0));
  cdisplay(2,30,20,_CVT_13(0));
  cdisplay(2,31,20,_CVT_21(0));
  cdisplay(2,26,49,_CVT_11(0));
  cdisplay(2,27,49,_CVT_21(0));
  cdisplay(2,27,62,_CVT_21(0));
  cdisplay(2,28,49,Off_On_text[0]);
  cdisplay(2,28,56,Off_On_text[0]);
  cdisplay(2,28,67,Off_On_text[0]);
  cdisplay(2,30,49,_CVT_11(0));
  cdisplay(2,31,49,_CVT_21(0));
  cdisplay(2,31,62,_CVT_21(0));
  cdisplay(2,32,49,Off_On_text[0]);
  cdisplay(2,32,56,Off_On_text[0]);
  cdisplay(2,32,67,Off_On_text[0]);
  cdisplay(2,3,65,_CVT_5(0));
  cdisplay(2,4,65,_CVT_5(0));
  cdisplay(2,5,65,_CVT_5(0));
  cdisplay(2,6,65,_CVT_5(0));
  cdisplay(2,7,65,_CVT_5(0));
  cdisplay(2,8,65,_CVT_5(0));
  cdisplay(2,10,65,_CVT_5(0));
  cdisplay(2,11,65,_CVT_5(0));
  cdisplay(2,12,65,_CVT_5(0));
  cdisplay(2,13,65,_CVT_5(0));
  cdisplay(2,14,65,_CVT_5(0));
  cdisplay(2,15,65,_CVT_5(0));
  cdisplay(2,17,65,_CVT_5(0));
  cdisplay(2,18,65,_CVT_5(0));
  cdisplay(2,19,65,_CVT_5(0));
  cdisplay(2,20,65,_CVT_5(0));
  cdisplay(2,21,65,_CVT_5(0));
  cdisplay(2,22,65,_CVT_5(0));
  cdisplay(2,23,65,_CVT_5(0));
}
#define TMINITFUNC tminitfunc()

static void nullfunc(void);
static void EF2_0(void) {
  {
  
  	for(chanInc=0; chanInc<MAXMSDCHANS; chanInc++) {
  		MSD_ChanX = MSDMISSING;
  		switch( chanInc ) {
  			case 0:
  				MSD_ChanX = home->U73.MSD_Chan0; break;
  			case 1:
  				MSD_ChanX = home->U80.MSD_Chan1; break;
  			case 2:
  				MSD_ChanX = home->U70.MSD_Chan2; break;
  			case 3:
  				MSD_ChanX = home->U20.MSD_Chan3; break;
  			case 4:
  				MSD_ChanX = home->U2.MSD_Chan4; break;
  			case 5:
  				MSD_ChanX = home->U2.MSD_Chan5; break;
  			case 6:
  				MSD_ChanX = home->U2.MSD_Chan5; break;
  			case 7:
  				MSD_ChanX = home->U2.MSD_Chan5; break;
  			default:
  				chanInc = MAXMSDCHANS-1; MSD_ChanX = MSDMISSING; break;
  		}
  
  		if ( MSD_ChanX > 0 ) {
  			msd_sum[chanInc] += MSD_ChanX;
  			MSchanAvg[chanInc]++;
  		}
  	}
  }
  if ( home->U73.MSD_Chan0 >= 0 )if (!(V20)) {
    {
      	rtg_report( msdChan0_rtg[ msdChan0_rtginc ], home->U2.MSD_TimePlot, home->U73.MSD_Chan0 );
    }
  }
  if ( home->U80.MSD_Chan1 >= 0 )if (!(V21)) {
    {
      	rtg_report( msdChan1_rtg[ msdChan1_rtginc ], home->U2.MSD_TimePlot, home->U80.MSD_Chan1 );
    }
  }
  if ( home->U70.MSD_Chan2 >= 0 )if (!(V22)) {
    {
      	rtg_report( msdChan2_rtg[ msdChan2_rtginc ], home->U2.MSD_TimePlot, home->U70.MSD_Chan2 );
    }
  }
  if ( home->U20.MSD_Chan3 >= 0 )if (!(V23)) {
    {
      	rtg_report( msdChan3_rtg[ msdChan3_rtginc ], home->U2.MSD_TimePlot, home->U20.MSD_Chan3 );
    }
  }
  if ( home->U2.MSD_Chan4 >= 0 )if (!(V24)) {
    {
      	rtg_report( msdChan4_rtg[ msdChan4_rtginc ], home->U2.MSD_TimePlot, home->U2.MSD_Chan4 );
    }
  }
  if ( home->U2.MSD_Chan5 >= 0 )if (!(V25)) {
    {
      	rtg_report( msdChan5_rtg[ msdChan5_rtginc ], home->U2.MSD_TimePlot, home->U2.MSD_Chan5 );
    }
  }
  display_(2,7,12,
   MSD_DataType,home->U2.MSD_Time,_CVT_6(home->U2.MSD_Time));
}

static void BF32_0(void) {
  EF2_0();
  if (!(V0)) {
    {
      if ( home->U12.GCstate == 2 ) VSET_0_(3);
    }
  }
    else {
      if ( home->U12.GCstate == 1 ) VSET_0_(2);
      if ( home->U12.GCstate == 0 ) VSET_0_(1);
    }
  {if (!(V1)) {
    { CHROMtime += 1; InjectingInc = 0; {
      display_(0,1,14,
      ULONG,CHROMtime,_CVT_22(CHROMtime));
    }
    }
  }if (!(V2)) {
    { 
    	if (InjectingInc == 0 ) {
    		CHROMtime = 1; 
    		InjectingInc = 1;
    	}
    	else CHROMtime += 1; {
      display_(0,1,14,
      ULONG,CHROMtime,_CVT_22(CHROMtime));
    }
    }
  }
  }
  {	
  	if (rs485_proxy != 0)  Trigger ( rs485_proxy );
  }
  {
  	if (ECDresp_proxy != 0) Trigger ( ECDresp_proxy );
  }
  {if (!(V3)) {
    { VSET_1_(1);
    	}
  }if (!(V4)) {
    V4 |= 0x1;
    { VSET_1_(2);
    		ecdSF6x = 0.0;
    		ecdF11x = 0.0;
    		ecdCOx  = 0.0;
    		ecdPANx = 0.0;
    	}
  }
  
  	if ( ecdSF6x > NUMSECSXAXIS ) { VSET_1_(2);
  		ecdSF6x = 0.0;
  		ecdF11x = 0.0;
  		ecdCOx  = 0.0;
  		ecdPANx = 0.0;
  	}
  }
  {
  	if ( DetAvgCt1 > 0 ) {
  		ecdA_SF6 = ecd_sum1/DetAvgCt1;
  		ecdA_SF6save = ecdA_SF6;
  		DetAvgCt1 = 0;
  		ecd_sum1 = 0;
  		DetAvgOffline1 = 0;
  	} 
  	else if (( ecdA_SF6save > 0 ) && ( DetAvgOffline1 < 1 )) {
  		DetAvgOffline1++;
  		ecdA_SF6 = ecdA_SF6save;
  	}
  	else {
  		ecdA_SF6 = ECDOFFLINE;
  		ecdA_SF6save = 0;
  	} {
    display_(0,13,7,
    
    GC_Freq,ecdA_SF6,_CVT_9(ecdA_SF6));
  }
  if ( DetAvgCt2 > 0 ) {
  		ecdA_F11 = ecd_sum2/DetAvgCt2;
  		ecdA_F11save = ecdA_F11;
  		DetAvgCt2 = 0;
  		ecd_sum2 = 0;
  		DetAvgOffline2 = 0;
  	} 
  	else if (( ecdA_F11save > 0 ) && ( DetAvgOffline2 < 1 )) {
  		DetAvgOffline2++;
  		ecdA_F11 = ecdA_F11save;
  	}
  	else {
  		ecdA_F11 = ECDOFFLINE;
  		ecdA_F11save = 0;
  	} {
    display_(0,13,42,
    
    GC_Freq,ecdA_F11,_CVT_9(ecdA_F11));
  }
  if ( DetAvgCt3 > 0 ) {
  		ecdA_CO = ecd_sum3/DetAvgCt3;
  		ecdA_COsave = ecdA_CO;
  		DetAvgCt3 = 0;
  		ecd_sum3 = 0;
  		DetAvgOffline3 = 0;
  	} 
  	else if (( ecdA_COsave > 0 ) && ( DetAvgOffline3 < 1 )) {
  		DetAvgOffline3++;
  		ecdA_CO = ecdA_COsave;
  	}
  	else {
  		ecdA_CO = ECDOFFLINE;
  		ecdA_COsave = 0;
  	} {
    display_(0,23,7,
    
    GC_Freq,ecdA_CO,_CVT_9(ecdA_CO));
  }
  if ( DetAvgCt4 > 0 ) {
  		ecdA_PAN = ecd_sum4/DetAvgCt4;
  		ecdA_PANsave = ecdA_PAN;
  		DetAvgCt4 = 0;
  		ecd_sum4 = 0;
  		DetAvgOffline4 = 0;
  	} 
  	else if (( ecdA_PANsave > 0 ) && ( DetAvgOffline4 < 1 )) {
  		DetAvgOffline4++;
  		ecdA_PAN = ecdA_PANsave;
  	}
  	else {
  		ecdA_PAN = ECDOFFLINE;
  		ecdA_PANsave = 0;
  	} {
    display_(0,23,42,
    
    GC_Freq,ecdA_PAN,_CVT_9(ecdA_PAN));
  }
  }
  {
   	++CUMSEC; {
    display_(0,2,14,
    
    
    
    
    ULONG,CUMSEC,_CVT_22(CUMSEC));
    display_(2,11,14,
    
    
    
    
    ULONG,CUMSEC,_CVT_22(CUMSEC));
  }
  }
  {
  	if ( MSchanAvg[0] > 0 ) {
  		msdA_0 = msd_sum[0]/MSchanAvg[0];
  		MSchanAvg[0] = msd_sum[0] = 0;
  	} else {
  		msdA_0 = MSDOFFLINE;
  	} {
    display_(2,3,10,
    
    MSD_DataType,msdA_0,_CVT_6(msdA_0));
  }
  if ( MSchanAvg[1] > 0 ) {
  		msdA_1 = msd_sum[1]/MSchanAvg[1];
  		MSchanAvg[1] = msd_sum[1] = 0;
  	} else {
  		msdA_1 = MSDOFFLINE;
  	} {
    display_(2,4,10,
    
    MSD_DataType,msdA_1,_CVT_6(msdA_1));
  }
  if ( MSchanAvg[2] > 0 ) {
  		msdA_2 = msd_sum[2]/MSchanAvg[2];
  		MSchanAvg[2] = msd_sum[2] = 0;
  	} else {
  		msdA_2 = MSDOFFLINE;
  	} {
    display_(2,5,10,
    
    MSD_DataType,msdA_2,_CVT_6(msdA_2));
  }
  if ( MSchanAvg[3] > 0 ) {
  		msdA_3 = msd_sum[3]/MSchanAvg[3];
  		MSchanAvg[3] = msd_sum[3] = 0;
  	} else {
  		msdA_3 = MSDOFFLINE;
  	} {
    display_(2,6,10,
    
    MSD_DataType,msdA_3,_CVT_6(msdA_3));
  }
  if ( MSchanAvg[4] > 0 ) {
  		msdA_4 = msd_sum[4]/MSchanAvg[4];
  		MSchanAvg[4] = msd_sum[4] = 0;
  	} else {
  		msdA_4 = MSDOFFLINE;
  	} {
    display_(2,3,30,
    
    MSD_DataType,msdA_4,_CVT_6(msdA_4));
  }
  if ( MSchanAvg[5] > 0 ) {
  		msdA_5 = msd_sum[5]/MSchanAvg[5];
  		MSchanAvg[5] = msd_sum[5] = 0;
  	} else {
  		msdA_5 = MSDOFFLINE;
  	} {
    display_(2,4,30,
    
    MSD_DataType,msdA_5,_CVT_6(msdA_5));
  }
  if ( MSchanAvg[6] > 0 ) {
  		msdA_6 = msd_sum[6]/MSchanAvg[6];
  		MSchanAvg[6] = msd_sum[6] = 0;
  	} else {
  		msdA_6 = MSDOFFLINE;
  	}
  
  	if ( MSchanAvg[7] > 0 ) {
  		msdA_7 = msd_sum[7]/MSchanAvg[7];
  		MSchanAvg[7] = msd_sum[7] = 0;
  	} else {
  		msdA_7 = MSDOFFLINE;
  	}
  
  }
  {if (!(V6)) {
    { 
    	MSDchromtime += 1; 
    	InjectingInc_MSD = 0; {
      display_(2,10,14,
      
      ULONG,MSDchromtime,_CVT_22(MSDchromtime));
    }
    }
  }if (!(V7)) {
    { 
    	if ( InjectingInc_MSD == 0 ) {
    		MSDchromtime = 1; 
    		InjectingInc_MSD = 1;
    	} else 
    		MSDchromtime += 1; {
      display_(2,10,14,
      
      ULONG,MSDchromtime,_CVT_22(MSDchromtime));
    }
    }
  }
  }
  {
  	if (maycomm_proxy != 0)  Trigger ( maycomm_proxy );
  }
}

static void EF2_1(void) {
  {
  	if (home->U0.GC_Ctr_SF6 >= 0) {
  		ecd_sum1 += home->U0.GC_Ctr_SF6;
  		DetAvgCt1++;
  		ecdSF6x += ELECRATE;
  	} 
  	if (home->U0.GC_Ctr_F11 >= 0) {
  		ecd_sum2 += home->U0.GC_Ctr_F11;
  		DetAvgCt2++;
  		ecdF11x += ELECRATE;
  	}
  	if (home->U0.GC_Ctr_CO >= 0) {
  		ecd_sum3 += home->U0.GC_Ctr_CO;
  		DetAvgCt3++;
  		ecdCOx += ELECRATE;
  	}
  	if (home->U0.GC_Ctr_PAN >= 0) {
  		ecd_sum4 += home->U0.GC_Ctr_PAN;
  		DetAvgCt4++;
  		ecdPANx += ELECRATE;
  	}
  }
  if ( home->U0.GC_Ctr_SF6 >= 0 )if (!(V10)) {
    {
      	rtg_report( chromSF6_rtg[ chromSF6_rtginc ], ecdSF6x, home->U0.GC_Ctr_SF6 );
    }
  }
  if ( home->U0.GC_Ctr_F11 >= 0 )if (!(V11)) {
    {
      	rtg_report( chromF11_rtg[ chromF11_rtginc ], ecdF11x, home->U0.GC_Ctr_F11 );
    }
  }
  if ( home->U0.GC_Ctr_CO >= 0 )if (!(V12)) {
    {
      	rtg_report( chromCO_rtg[ chromCO_rtginc ], ecdCOx, home->U0.GC_Ctr_CO );
    }
  }
  if ( home->U0.GC_Ctr_PAN >= 0 )if (!(V13)) {
    {
      	rtg_report( chromPAN_rtg[ chromPAN_rtginc ], ecdPANx, home->U0.GC_Ctr_PAN );
    }
  }
}

static void EF8_1(void) {
  EF2_1();
  display_(2,28,49,
  	 Bit_Off_On,home->U2.trap1heat,Off_On_text[home->U2.trap1heat]);
  display_(2,32,49, 
  	 Bit_Off_On,home->U0.trap2heat,Off_On_text[home->U0.trap2heat]);
}

static void EF16_1(void) {
  EF8_1();
  display_(0,1,62,
  
  	 Bit_HI_LO,home->U17.faildummy,HI_LO_text[home->U17.faildummy]);
}

static void BF32_1(void) {
  tdlbH2O = home->U98.tdlbH2O;
  maycX = home->U95.maycX; {
    V19 &= ~0x2;
    V18 &= ~0x2;
    V9 &= ~0x2;
  }
  EF16_1();
  {
  		MSDstateS = home->U15.MSDstate;
  	}
  if (!(V5)) {
    {
      if ( home->U15.MSDstate == 2 ) VSET_2_(3);
    }
  }
    else {
      if ( home->U15.MSDstate == 1 ) VSET_2_(2);
      else if ( home->U15.MSDstate == 0 ) VSET_2_(1);
    }
  maycX++;
  {if (!(V8)) {
    { VSET_3_(1); }
  }
  
  	if ( maycX >= 120 ) { 
  		maycX = 0; VSET_3_(2);
  	}
  }
  display_(1,27,11,
  
   tdlfloat,tdlbH2O,_CVT_3(tdlbH2O));
  display_(2,15,12, 
   UCHAR,home->U15.MSDstate,_CVT_23[home->U15.MSDstate]);
}

static void BF320_2(void) {
  memcpy(&VoltE_SF6, home->U113.U115, 1);
  V33 &= ~0x1;
  EF2_0();
}

static void BF32_3(void) {
  memcpy(&tdllH2O, home->U719.U721, 1); {
    V73 &= ~0x1;
    V19 &= ~0x4;
    V9 &= ~0x1;
  }
  EF2_1();
  display_(1,24,38,	
   tdlint6,home->U95.tdlsAmp,SS_6_224_d_0(home->U95.tdlsAmp));
  display_(1,25,38,
   tdlint6,home->U95.tdlsPow,SS_6_224_d_0(home->U95.tdlsPow));
  display_(1,26,38,
   tdlint6,home->U98.tdlsPos,SS_6_224_d_0(home->U98.tdlsPos));
  display_(1,27,38,
   tdlint6,home->U98.tdlsZer,SS_6_224_d_0(home->U98.tdlsZer));
  display_(1,24,60,	
   tdlint6,home->U95.tdllAmp,SS_6_224_d_0(home->U95.tdllAmp));
  display_(1,25,60,
   tdlint6,home->U80.tdllPow,SS_6_224_d_0(home->U80.tdllPow));
  display_(1,26,60,
   tdlint6,home->U58.tdllPos,SS_6_224_d_0(home->U58.tdllPos));
  display_(1,27,60,
   tdlint6,home->U58.tdllZer,SS_6_224_d_0(home->U58.tdllZer));
}

static void BF320_4(void) {
  memcpy(&Flow_PANsl, home->U305.U307, 1);
  V31 &= ~0x1;
  EF2_0();
}

static void BF32_5(void) {
  memcpy(((char*)(&tdllH2O))+1, home->U55.U57, 3);
  EF2_1();
  if (!(V9)) {
    {
    	tdlbH2O = tdllH2O;
    	if ( tdllH2O > USELONGPATH ) tdlbH2O = home->U55.tdlsH2O; 
    }
  }
  if ( home->U55.tdlP > 0 ) {if (!(V18)) {
    {
      	rtg_report( TDLshort_rtg[ TDLshort_rtginc ], maycX, home->U55.tdlsH2O );
    }
  }if (!(V19)) {
    {
      	rtg_report( TDLlong_rtg[ TDLlong_rtginc ] , maycX, tdllH2O );
    }
  }
  }
  display_(0,25,7,
   OmegaT,home->U55.CO_Col,_CVT_11(home->U55.CO_Col));
  display_(1,18,33,
   OmegaT,home->U55.CO_Col,_CVT_11(home->U55.CO_Col));
  display_(1,23,11, 
   tdlfloas,home->U55.tdlT,_CVT_1(home->U55.tdlT));
  display_(1,24,11,
  
  
   tdlfloas,home->U55.tdlP,_CVT_1(home->U55.tdlP));
  display_(1,23,36, 
   tdlfloat,home->U55.tdlsH2O,_CVT_3(home->U55.tdlsH2O));
  if (!(V73)) {
    display_(1,23,58,
     tdlfloat,tdllH2O,_CVT_3(tdllH2O));
  }
}

static void BF320_6(void) {
  memcpy(((char*)(&Flow_PANsl))+1, home->U302.U304, 1);
  V31 &= ~0x2;
  EF2_0();
}

static void EF32_7(void) {
  EF2_1();
  display_(0,8,10,
  
   valvT,home->U76.ssv1,_CVT_8(home->U76.ssv1));
  display_(0,8,17,
   valvT,home->U70.ssv2,_CVT_8(home->U70.ssv2));
  display_(0,12,25,
   valvetext,home->U76.valv_SF6,Load_Inject_text[home->U76.valv_SF6]);
  display_(0,12,59,
   valvetext,home->U76.valv_F11,Load_Inject_text[home->U76.valv_F11]);
  display_(0,22,24,
   valvetext,home->U80.valv_CO,Load_Inject_text[home->U80.valv_CO]);
  display_(0,22,59,
   valvetext,home->U67.valv_PAN,Load_Inject_text[home->U67.valv_PAN]);
  display_(2,14,11,
   valvT,home->U70.ssv2,_CVT_8(home->U70.ssv2));
  display_(2,14,29,
  
   valvT,home->U76.ssv1,_CVT_8(home->U76.ssv1));
  display_(2,16,11,
   valveMS1text,home->U17.valv_MS1,Inj2_Inj1_text[home->U17.valv_MS1]);
  display_(2,16,29,
   valveMS2text,home->U17.valv_MS2,Inj2_Inj1_text[home->U17.valv_MS2]);
}

static void BF320_7(void) {
  memcpy(((char*)(&Flow_PANsl))+2, home->U299.U301, 1);
  V31 &= ~0x4;
  EF32_7();
}

static void BF320_8(void) {
  memcpy(((char*)(&Flow_PANsl))+3, home->U296.U298, 1);
  EF2_0();
  if (!(V31)) {
    display_(0,6,42,
    	 adT,Flow_PANsl,_CVT_21(Flow_PANsl));
  }
}

static void EF32_9(void) {
  EF8_1();
  display_(1,3,18,
  	 adT,home->U15.Temp_SF6sl,_CVT_21(home->U15.Temp_SF6sl));
  display_(1,10,18,
  	 adT,home->U15.Temp_Ipump,_CVT_21(home->U15.Temp_Ipump));
  display_(1,11,18,
  	 adT,home->U15.Temp_PANsrc,_CVT_21(home->U15.Temp_PANsrc));
}

static void BF320_9(void) {
  memcpy(&Flow_Packsl, home->U293.U295, 1);
  V28 &= ~0x1;
  EF32_9();
}

static void BF320_10(void) {
  memcpy(((char*)(&Flow_Packsl))+1, home->U290.U292, 1);
  V28 &= ~0x2;
  EF2_0();
}

static void EF32_11(void) {
  EF2_1();
  { ITXFileNum = home->U12.CurrInj * 1000 + home->U2.CurrFile;
  }
  display_(0,1,32,
   UINT,home->U12.CurrInj,US_5_0_u_0(home->U12.CurrInj));
  display_(0,15,42,
  
   OmegaT,home->U67.F11_Col,_CVT_11(home->U67.F11_Col));
  display_(0,24,7,
   OmegaT,home->U9.CO_ECD,_CVT_11(home->U9.CO_ECD));
  display_(0,24,20,
   OmegaTsp,home->U64.CO_ECD_Sp,_CVT_10(home->U64.CO_ECD_Sp));
  display_(0,25,20,
   OmegaTsp,home->U15.CO_Col_Sp,_CVT_10(home->U15.CO_Col_Sp));
  display_(1,17,33,
  
   OmegaT,home->U67.F11_Col,_CVT_11(home->U67.F11_Col));
  display_(1,18,12,
   OmegaT,home->U9.CO_ECD,_CVT_11(home->U9.CO_ECD));
  display_(1,18,20,
   OmegaTsp,home->U64.CO_ECD_Sp,_CVT_10(home->U64.CO_ECD_Sp));
  display_(1,18,41,
   OmegaTsp,home->U15.CO_Col_Sp,_CVT_10(home->U15.CO_Col_Sp));
  display_(2,10,35,
  
  
  
   UINT,home->U76.CurrInj_MSD,US_5_0_u_0(home->U76.CurrInj_MSD));
}

static void BF320_11(void) {
  memcpy(((char*)(&Flow_Packsl))+2, home->U287.U289, 1);
  V28 &= ~0x4;
  EF32_11();
}

static void BF320_12(void) {
  memcpy(((char*)(&Flow_Packsl))+3, home->U284.U286, 1);
  EF2_0();
  if (!(V28)) {
    display_(0,5,42,
    	 adT,Flow_Packsl,_CVT_21(Flow_Packsl));
  }
}

static void EF32_13(void) {
  EF2_1();
  display_(0,9,35,
  	 Bit_Off_On,home->U61.PANflowCont,Off_On_text[home->U61.PANflowCont]);
  display_(0,7,63,
  	 Bit_Cl_Op,home->U58.PANflsh,Cl_Op_text[home->U58.PANflsh]);
  display_(0,14,42,
   OmegaT,home->U6.F11_ECD,_CVT_11(home->U6.F11_ECD));
  display_(0,14,55,
   OmegaTsp,home->U61.F11_ECD_Sp,_CVT_10(home->U61.F11_ECD_Sp));
  display_(0,15,55,
  
   OmegaTsp,home->U12.F11_Col_Sp,_CVT_10(home->U12.F11_Col_Sp));
  display_(0,24,42,
   OmegaT,home->U70.PAN_ECD,_CVT_11(home->U70.PAN_ECD));
  display_(0,24,55,
   OmegaTsp,home->U70.PAN_ECD_Sp,_CVT_10(home->U70.PAN_ECD_Sp));
  display_(1,17,12,
   OmegaT,home->U6.F11_ECD,_CVT_11(home->U6.F11_ECD));
  display_(1,17,20,
   OmegaTsp,home->U61.F11_ECD_Sp,_CVT_10(home->U61.F11_ECD_Sp));
  display_(1,17,41,
  
   OmegaTsp,home->U12.F11_Col_Sp,_CVT_10(home->U12.F11_Col_Sp));
  display_(1,19,12,
   OmegaT,home->U70.PAN_ECD,_CVT_11(home->U70.PAN_ECD));
  display_(1,19,20,
   OmegaTsp,home->U70.PAN_ECD_Sp,_CVT_10(home->U70.PAN_ECD_Sp));
  display_(2,11,37,
   WinNum,home->U83.IonWinNum,_CVT_7(home->U83.IonWinNum));
}

static void BF320_13(void) {
  memcpy(&Flow_MSsl, home->U281.U283, 1);
  V75 &= ~0x1;
  EF32_13();
}

static void BF320_14(void) {
  memcpy(((char*)(&Flow_MSsl))+1, home->U278.U280, 1);
  V75 &= ~0x2;
  EF2_0();
}

static void EF32_15(void) {
  EF2_1();
  display_(0,8,26,
  
  	 Bit_Air_Cal,home->U2.PANsol1,Air_Cal_text[home->U2.PANsol1]);
  display_(0,9,29,
  	 Bit_Off_On,home->U0.PANlamp,Off_On_text[home->U0.PANlamp]);
  display_(0,9,41,
  	 Bit_Off_On,home->U67.PANsol3,Off_On_text[home->U67.PANsol3]);
  display_(0,2,62,
  	 Bit_HI_LO,home->U61.pilotTrip,HI_LO_text[home->U61.pilotTrip]);
  display_(0,6,56,
  	 Bit_Cl_Op,home->U58.PANsol2,Cl_Op_text[home->U58.PANsol2]);
  display_(0,6,62,
  	 Bit_Op_Cl,home->U64.PANsol4,Op_Cl_text[home->U64.PANsol4]);
  display_(2,28,67,
  	 Bit_Off_On,home->U61.pelt1State,Off_On_text[home->U61.pelt1State]);
  display_(2,32,67,
  	 Bit_Off_On,home->U20.pelt2State,Off_On_text[home->U20.pelt2State]);
}

static void BF320_15(void) {
  memcpy(((char*)(&Flow_MSsl))+2, home->U275.U277, 1);
  V75 &= ~0x4;
  EF32_15();
}

static void BF320_16(void) {
  memcpy(((char*)(&Flow_MSsl))+3, home->U272.U274, 1);
  EF2_0();
  if (!(V75)) {
    display_(2,20,8,
    
    	
    	 adT,Flow_MSsl,_CVT_21(Flow_MSsl));
  }
}

static void EF32_17(void) {
  EF16_1();
  display_(0,14,7,
   OmegaT,home->U64.SF6_ECD,_CVT_11(home->U64.SF6_ECD));
  display_(0,14,20,
   OmegaTsp,home->U70.SF6_ECD_Sp,_CVT_10(home->U70.SF6_ECD_Sp));
  display_(0,15,7,
   OmegaT,home->U67.SF6_Col,_CVT_11(home->U67.SF6_Col));
  display_(0,15,20,
   OmegaTsp,home->U67.SF6_Col_Sp,_CVT_10(home->U67.SF6_Col_Sp));
  display_(1,16,12,
   OmegaT,home->U64.SF6_ECD,_CVT_11(home->U64.SF6_ECD));
  display_(1,16,20,
   OmegaTsp,home->U70.SF6_ECD_Sp,_CVT_10(home->U70.SF6_ECD_Sp));
  display_(1,16,33,
   OmegaT,home->U67.SF6_Col,_CVT_11(home->U67.SF6_Col));
  display_(1,16,41,
   OmegaTsp,home->U67.SF6_Col_Sp,_CVT_10(home->U67.SF6_Col_Sp));
}

static void BF320_17(void) {
  memcpy(&ColT_MS1, home->U221.U223, 1);
  V78 &= ~0x1;
  EF32_17();
}

static void BF320_18(void) {
  memcpy(((char*)(&ColT_MS1))+1, home->U218.U220, 1);
  V78 &= ~0x2;
  EF2_0();
}

static void EF32_19(void) {
  EF2_1();
  display_(0,5,56,
  	 Bit_Cl_Op,home->U20.SLoopIN,Cl_Op_text[home->U20.SLoopIN]);
  display_(0,5,62,
  	 Bit_Cl_Op,home->U35.SLoopOUT,Cl_Op_text[home->U35.SLoopOUT]);
  display_(0,16,7,
   OmegaT,home->U6.SF6_Post,_CVT_11(home->U6.SF6_Post));
  display_(0,16,20,
   OmegaTsp,home->U12.SF6_Post_Sp,_CVT_10(home->U12.SF6_Post_Sp));
  display_(1,16,54,
   OmegaT,home->U6.SF6_Post,_CVT_11(home->U6.SF6_Post));
  display_(1,16,62,
   OmegaTsp,home->U12.SF6_Post_Sp,_CVT_10(home->U12.SF6_Post_Sp));
  display_(1,20,18,
   OmegaT,home->U64.Trap1_CB,_CVT_11(home->U64.Trap1_CB));
  display_(1,20,26,
   OmegaTsp,home->U67.Trap1_CB_Sp,_CVT_10(home->U67.Trap1_CB_Sp));
  display_(2,21,16,
  	 Bit_Op_Cl,home->U64.SLoopMSout,Op_Cl_text[home->U64.SLoopMSout]);
  display_(2,26,49,
   OmegaT,home->U64.Trap1_CB,_CVT_11(home->U64.Trap1_CB));
  display_(2,28,56,
  	 Bit_Off_On,home->U64.trap1relay,Off_On_text[home->U64.trap1relay]);
}

static void BF320_19(void) {
  memcpy(((char*)(&ColT_MS1))+2, home->U215.U217, 1);
  V78 &= ~0x4;
  EF32_19();
}

static void BF320_20(void) {
  memcpy(((char*)(&ColT_MS1))+3, home->U212.U214, 1);
  EF2_0();
  if (!(V78)) {
    display_(2,28,20,
    
    	
    	 adT,ColT_MS1,_CVT_21(ColT_MS1));
  }
}

static void EF32_21(void) {
  EF2_1();
  display_(1,20,38,
   OmegaT,home->U9.Trap2_CB,_CVT_11(home->U9.Trap2_CB));
  display_(1,20,46,
   OmegaTsp,home->U15.Trap2_CB_Sp,_CVT_10(home->U15.Trap2_CB_Sp));
  display_(2,30,49,
   OmegaT,home->U9.Trap2_CB,_CVT_11(home->U9.Trap2_CB));
  display_(2,32,56,
  	 Bit_Off_On,home->U35.trap2relay,Off_On_text[home->U35.trap2relay]);
}

static void EF64_21(void) {
  memcpy(&msdMASO, home->U92.U94, 3);
  V92 &= ~0x1;
  EF32_21();
}

static void BF320_21(void) {
  memcpy(((char*)(&VoltE_SF6))+1, home->U31.U34, 2);
  memcpy(&VoltBP_5, home->U101.U103, 2); {
    V76 &= ~0x1;
    V33 &= ~0x2;
  }
  EF64_21();
  display_(2,19,21,
  	 vdc_chan,home->U108.VoltE_5,_CVT_17(home->U108.VoltE_5));
}

static void BF320_22(void) {
  memcpy(&ColT_MS2, home->U233.U235, 1);
  V80 &= ~0x1;
  EF2_0();
}

static void BF64_23(void) {
  memcpy(&msdTURBOPCT, home->U108.U110, 4);
  memcpy(((char*)(&msdMASO))+3, home->U52.U54, 5);
  V85 &= ~0x1;
  EF2_1();
  display_(2,21,65,
   MSDdouble,home->U52.msdMASG,_CVT_5(home->U52.msdMASG));
  if (!(V92)) {
    display_(2,22,65,
     MSDdouble,msdMASO,_CVT_5(msdMASO));
  }
}

static void BF320_24(void) {
  memcpy(((char*)(&ColT_MS2))+1, home->U230.U232, 1);
  V80 &= ~0x2;
  EF2_0();
}

static void BF64_25(void) {
  memcpy(&msdSRCTEMP, home->U716.U718, 1);
  memcpy(((char*)(&msdTURBOPCT))+4, home->U76.U78, 4);
  V86 &= ~0x1;
  EF8_1();
  if (!(V85)) {
    display_(2,3,65,
     MSDdouble,msdTURBOPCT,_CVT_5(msdTURBOPCT));
  }
  display_(2,8,65,
   MSDdouble,home->U86.msdQUAD,_CVT_5(home->U86.msdQUAD));
}

static void BF320_26(void) {
  memcpy(((char*)(&ColT_MS2))+2, home->U227.U229, 1);
  V80 &= ~0x4;
  EF2_0();
}

static void BF64_27(void) {
  memcpy(&msdCAL, home->U101.U104, 2);
  memcpy(((char*)(&msdSRCTEMP))+1, home->U48.U50, 7);
  V93 &= ~0x1;
  EF2_1();
  display_(2,6,65,
   MSDdouble,home->U48.msdEMUL,_CVT_5(home->U48.msdEMUL));
  if (!(V86)) {
    display_(2,7,65,
     MSDdouble,msdSRCTEMP,_CVT_5(msdSRCTEMP));
  }
}

static void BF320_28(void) {
  memcpy(((char*)(&ColT_MS2))+3, home->U224.U226, 1);
  EF2_0();
  if (!(V80)) {
    display_(2,31,20,
    	 adT,ColT_MS2,_CVT_21(ColT_MS2));
  }
}

static void BF64_29(void) {
  memcpy(&msdENTO, home->U89.U91, 3);
  memcpy(((char*)(&msdCAL))+2, home->U43.U45, 6);
  V90 &= ~0x1;
  EF2_1();
  display_(2,5,65,
   MSDdouble,home->U89.msdHEDEN,_CVT_5(home->U89.msdHEDEN));
  if (!(V93)) {
    display_(2,23,65,
     MSDdouble,msdCAL,_CVT_5(msdCAL));
  }
}

static void BF320_30(void) {
  memcpy(&ColT_PAN, home->U245.U247, 1);
  V37 &= ~0x1;
  EF2_0();
}

static void BF64_31(void) {
  memcpy(&msdFSEL, home->U105.U107, 4);
  memcpy(((char*)(&msdENTO))+3, home->U40.U42, 5);
  V87 &= ~0x1;
  EF2_1();
  if (!(V90)) {
    display_(2,15,65,
     MSDdouble,msdENTO,_CVT_5(msdENTO));
  }
  display_(2,19,65,
   MSDdouble,home->U40.msdMMW,_CVT_5(home->U40.msdMMW));
}

static void BF320_34(void) {
  memcpy(((char*)(&ColT_PAN))+1, home->U242.U244, 1);
  V37 &= ~0x2;
  EF2_0();
}

static void BF320_36(void) {
  memcpy(((char*)(&ColT_PAN))+2, home->U239.U241, 1);
  V37 &= ~0x4;
  EF2_0();
}

static void BF320_38(void) {
  memcpy(((char*)(&ColT_PAN))+3, home->U236.U238, 1);
  EF2_0();
  if (!(V37)) {
    display_(0,25,42,
    	 adT,ColT_PAN,_CVT_21(ColT_PAN));
  }
}

static void BF320_39(void) {
  memcpy(&Pow_m15, home->U665.U667, 1);
  V54 &= ~0x1;
  EF32_7();
}

static void BF320_40(void) {
  memcpy(((char*)(&Pow_m15))+1, home->U662.U664, 1);
  V54 &= ~0x2;
  EF2_0();
}

static void BF320_41(void) {
  memcpy(((char*)(&Pow_m15))+2, home->U659.U661, 1);
  V54 &= ~0x4;
  EF32_9();
}

static void BF320_42(void) {
  memcpy(((char*)(&Pow_m15))+3, home->U656.U658, 1);
  EF2_0();
  if (!(V54)) {
    display_(1,10,42,
    	 vdc_pow,Pow_m15,_CVT_15(Pow_m15));
  }
}

static void BF320_43(void) {
  memcpy(&Pow_p12, home->U653.U655, 1);
  V55 &= ~0x1;
  EF32_11();
}

static void BF320_44(void) {
  memcpy(((char*)(&Pow_p12))+1, home->U650.U652, 1);
  V55 &= ~0x2;
  EF2_0();
}

static void BF320_45(void) {
  memcpy(((char*)(&Pow_p12))+2, home->U647.U649, 1);
  V55 &= ~0x4;
  EF32_13();
}

static void BF320_46(void) {
  memcpy(((char*)(&Pow_p12))+3, home->U644.U646, 1);
  EF2_0();
  if (!(V55)) {
    display_(1,11,42,
    	 vdc_pow,Pow_p12,_CVT_15(Pow_p12));
  }
}

static void BF320_47(void) {
  memcpy(&Pow_p15, home->U677.U679, 1);
  V53 &= ~0x1;
  EF32_15();
}

static void BF320_48(void) {
  memcpy(((char*)(&Pow_p15))+1, home->U674.U676, 1);
  V53 &= ~0x2;
  EF2_0();
}

static void BF320_49(void) {
  memcpy(((char*)(&Pow_p15))+2, home->U671.U673, 1);
  V53 &= ~0x4;
  EF32_17();
}

static void BF320_50(void) {
  memcpy(((char*)(&Pow_p15))+3, home->U668.U670, 1);
  EF2_0();
  if (!(V53)) {
    display_(1,9,42,
    	 vdc_pow,Pow_p15,_CVT_15(Pow_p15));
  }
}

static void BF320_51(void) {
  memcpy(&Pow_p15pel1, home->U629.U631, 1);
  V51 &= ~0x1;
  EF32_19();
}

static void BF320_52(void) {
  memcpy(((char*)(&Pow_p15pel1))+1, home->U626.U628, 1);
  V51 &= ~0x2;
  EF2_0();
}

static void BF320_53(void) {
  memcpy(((char*)(&VoltE_SF6))+3, home->U2.U5, 1);
  memcpy(&VoltBP_CO, home->U20.U22, 2);
  V35 &= ~0x1;
  EF32_21();
  display_(0,5,24,
  	 vdc_chan,home->U17.VoltE_CO,_CVT_17(home->U17.VoltE_CO));
  display_(0,19,20,
  	 vdc_chan,home->U24.VoltBP_SF6,_CVT_17(home->U24.VoltBP_SF6));
  if (!(V33)) {
    display_(0,20,20,
    	 vdc_chan,VoltE_SF6,_CVT_17(VoltE_SF6));
  }
  display_(0,29,20,
  	 vdc_chan,home->U17.VoltE_CO,_CVT_17(home->U17.VoltE_CO));
}

static void BF320_54(void) {
  memcpy(((char*)(&Pow_p15pel1))+2, home->U623.U625, 1);
  V51 &= ~0x4;
  EF2_0();
}

static void BF64_55(void) {
  memcpy(&msdIFOC, home->U80.U82, 5);
  memcpy(((char*)(&msdFSEL))+4, home->U35.U37, 4);
  V89 &= ~0x1;
  EF2_1();
  if (!(V87)) {
    display_(2,10,65,
     MSDdouble,msdFSEL,_CVT_5(msdFSEL));
  }
  display_(2,14,65,
   MSDdouble,home->U73.msdENT,_CVT_5(home->U73.msdENT));
}

static void BF320_56(void) {
  memcpy(((char*)(&Pow_p15pel1))+3, home->U620.U622, 1);
  EF2_0();
  if (!(V51)) {
    display_(1,7,42,
    	 vdc_pow,Pow_p15pel1,_CVT_15(Pow_p15pel1));
  }
}

static void BF320_57(void) {
  memcpy(&PresE_5, home->U35.U39, 3);
  memcpy(((char*)(&VoltBP_5))+2, home->U12.U14, 2); {
    V74 &= ~0x1;
    V17 &= ~0x2;
  }
  EF8_1();
  if (!(V76)) {
    display_(2,23,24,
    	 vdc_chan,VoltBP_5,_CVT_17(VoltBP_5));
  }
  display_(2,26,33,			
  	 vdc_chan,home->U58.VoltMS1,_CVT_17(home->U58.VoltMS1));
  display_(2,29,33,
  	 vdc_chan,home->U61.VoltMS2,_CVT_17(home->U61.VoltMS2));
}

static void BF320_58(void) {
  memcpy(&Pow_p15pel2, home->U641.U643, 1);
  V52 &= ~0x1;
  EF2_0();
}

static void BF64_59(void) {
  memcpy(&msdAMUG, home->U43.U47, 6);
  memcpy(((char*)(&msdIFOC))+5, home->U31.U33, 3);
  V91 &= ~0x1;
  EF2_1();
  if (!(V89)) {
    display_(2,13,65,
     MSDdouble,msdIFOC,_CVT_5(msdIFOC));
  }
  display_(2,18,65,
   MSDdouble,home->U31.msdAMUO,_CVT_5(home->U31.msdAMUO));
}

static void BF320_60(void) {
  memcpy(((char*)(&Pow_p15pel2))+1, home->U638.U640, 1);
  V52 &= ~0x2;
  EF2_0();
}

static void BF64_61(void) {
  memcpy(&msdREP, home->U83.U85, 7);
  memcpy(((char*)(&msdAMUG))+6, home->U27.U29, 2);
  V88 &= ~0x1;
  EF2_1();
  display_(2,12,65,
   MSDdouble,home->U27.msdEEGY,_CVT_5(home->U27.msdEEGY));
  if (!(V91)) {
    display_(2,17,65,
     MSDdouble,msdAMUG,_CVT_5(msdAMUG));
  }
}

static void BF320_62(void) {
  memcpy(((char*)(&Pow_p15pel2))+2, home->U635.U637, 1);
  V52 &= ~0x4;
  EF2_0();
}

static void BF64_63(void) {
  memcpy(((char*)(&msdREP))+7, home->U24.U26, 1);
  EF2_1();
  display_(2,4,65,
  
   MSDdouble,home->U111.msdECUR,_CVT_5(home->U111.msdECUR));
  if (!(V88)) {
    display_(2,11,65,
     MSDdouble,msdREP,_CVT_5(msdREP));
  }
  display_(2,20,65,
   MSDdouble,home->U24.msdIPOL,_CVT_5(home->U24.msdIPOL));
}

static void BF320_66(void) {
  memcpy(((char*)(&Pow_p15pel2))+3, home->U632.U634, 1);
  EF2_0();
  if (!(V52)) {
    display_(1,8,42,
    	 vdc_pow,Pow_p15pel2,_CVT_15(Pow_p15pel2));
  }
}

static void BF320_68(void) {
  memcpy(&Pow_p24gsv, home->U701.U703, 1);
  V49 &= ~0x1;
  EF2_0();
}

static void BF320_70(void) {
  memcpy(((char*)(&Pow_p24gsv))+1, home->U698.U700, 1);
  V49 &= ~0x2;
  EF2_0();
}

static void BF320_71(void) {
  memcpy(((char*)(&Pow_p24gsv))+2, home->U695.U697, 1);
  V49 &= ~0x4;
  EF32_7();
}

static void BF320_72(void) {
  memcpy(((char*)(&Pow_p24gsv))+3, home->U692.U694, 1);
  EF2_0();
  if (!(V49)) {
    display_(1,5,42,
    	 vdc_pow,Pow_p24gsv,_CVT_15(Pow_p24gsv));
  }
}

static void BF320_73(void) {
  memcpy(&Pow_p24ms, home->U713.U715, 1);
  V50 &= ~0x1;
  EF32_9();
}

static void BF320_74(void) {
  memcpy(((char*)(&Pow_p24ms))+1, home->U710.U712, 1);
  V50 &= ~0x2;
  EF2_0();
}

static void BF320_75(void) {
  memcpy(((char*)(&Pow_p24ms))+2, home->U707.U709, 1);
  V50 &= ~0x4;
  EF32_11();
}

static void BF320_76(void) {
  memcpy(((char*)(&Pow_p24ms))+3, home->U704.U706, 1);
  EF2_0();
  if (!(V50)) {
    display_(1,6,42,
    	 vdc_pow,Pow_p24ms,_CVT_15(Pow_p24ms));
  }
}

static void BF320_77(void) {
  memcpy(&Pow_p28pri, home->U605.U607, 1);
  V47 &= ~0x1;
  EF32_13();
}

static void BF320_78(void) {
  memcpy(((char*)(&Pow_p28pri))+1, home->U602.U604, 1);
  V47 &= ~0x2;
  EF2_0();
}

static void BF320_79(void) {
  memcpy(((char*)(&Pow_p28pri))+2, home->U599.U601, 1);
  V47 &= ~0x4;
  EF32_15();
}

static void BF320_80(void) {
  memcpy(((char*)(&Pow_p28pri))+3, home->U596.U598, 1);
  EF2_0();
  if (!(V47)) {
    display_(1,3,42,
    
    	 vdc_pow,Pow_p28pri,_CVT_15(Pow_p28pri));
  }
}

static void BF320_81(void) {
  memcpy(&Pow_p28sec, home->U617.U619, 1);
  V48 &= ~0x1;
  EF32_17();
}

static void BF320_82(void) {
  memcpy(((char*)(&Pow_p28sec))+1, home->U614.U616, 1);
  V48 &= ~0x2;
  EF2_0();
}

static void BF320_83(void) {
  memcpy(((char*)(&Pow_p28sec))+2, home->U611.U613, 1);
  V48 &= ~0x4;
  EF32_19();
}

static void BF320_84(void) {
  memcpy(((char*)(&Pow_p28sec))+3, home->U608.U610, 1);
  EF2_0();
  if (!(V48)) {
    display_(1,4,42,
    	 vdc_pow,Pow_p28sec,_CVT_15(Pow_p28sec));
  }
}

static void BF320_85(void) {
  EF64_21();
  display_(0,18,55,
  	 vdc_chan,home->U52.VoltBP_F11,_CVT_17(home->U52.VoltBP_F11));
  display_(0,19,55,
  	 vdc_chan,home->U101.VoltE_F11,_CVT_17(home->U101.VoltE_F11));
}

static void BF320_86(void) {
  memcpy(&Pow_p5, home->U689.U691, 1);
  V56 &= ~0x1;
  EF2_0();
}

static void BF320_88(void) {
  memcpy(((char*)(&Pow_p5))+1, home->U686.U688, 1);
  V56 &= ~0x2;
  EF2_0();
}

static void BF320_90(void) {
  memcpy(((char*)(&Pow_p5))+2, home->U683.U685, 1);
  V56 &= ~0x4;
  EF2_0();
}

static void BF320_92(void) {
  memcpy(((char*)(&Pow_p5))+3, home->U680.U682, 1);
  EF2_0();
  if (!(V56)) {
    display_(1,12,42,
    	 vdc_pow,Pow_p5,_CVT_15(Pow_p5));
  }
}

static void BF320_94(void) {
  memcpy(&Pres_Inlet, home->U269.U271, 1);
  V26 &= ~0x1;
  EF2_0();
}

static void BF320_98(void) {
  memcpy(((char*)(&Pres_Inlet))+1, home->U266.U268, 1);
  V26 &= ~0x2;
  EF2_0();
}

static void BF320_100(void) {
  memcpy(((char*)(&Pres_Inlet))+2, home->U263.U265, 1);
  V26 &= ~0x4;
  EF2_0();
}

static void BF320_102(void) {
  memcpy(((char*)(&Pres_Inlet))+3, home->U260.U262, 1);
  EF2_0();
  if (!(V26)) {
    display_(0,4,16,
    	 adT,Pres_Inlet,_CVT_21(Pres_Inlet));
  }
}

static void BF320_103(void) {
  memcpy(&Pres_SL, home->U257.U259, 1);
  V27 &= ~0x1;
  EF32_7();
}

static void BF320_104(void) {
  memcpy(((char*)(&Pres_SL))+1, home->U254.U256, 1);
  V27 &= ~0x2;
  EF2_0();
}

static void BF320_105(void) {
  memcpy(((char*)(&Pres_SL))+2, home->U251.U253, 1);
  V27 &= ~0x4;
  EF32_9();
}

static void BF320_106(void) {
  memcpy(((char*)(&Pres_SL))+3, home->U248.U250, 1);
  EF2_0();
  if (!(V27)) {
    display_(0,5,16,
    
    
    	 adT,Pres_SL,_CVT_21(Pres_SL));
  }
}

static void BF320_107(void) {
  memcpy(&PresBP_PAN, home->U125.U127, 1);
  V29 &= ~0x1;
  EF32_11();
}

static void BF320_108(void) {
  memcpy(((char*)(&PresBP_PAN))+1, home->U122.U124, 1);
  V29 &= ~0x2;
  EF2_0();
}

static void BF320_109(void) {
  memcpy(((char*)(&PresBP_PAN))+2, home->U119.U121, 1);
  V29 &= ~0x4;
  EF32_13();
}

static void BF320_110(void) {
  memcpy(((char*)(&PresBP_PAN))+3, home->U116.U118, 1);
  EF2_0();
  if (!(V29)) {
    display_(0,6,16,	
    	 adT,PresBP_PAN,_CVT_21(PresBP_PAN));
  }
}

static void BF320_111(void) {
  memcpy(&PresH_Cal1, home->U377.U379, 1);
  V61 &= ~0x1;
  EF32_15();
}

static void BF320_112(void) {
  memcpy(((char*)(&PresH_Cal1))+1, home->U374.U376, 1);
  V61 &= ~0x2;
  EF2_0();
}

static void BF320_113(void) {
  memcpy(((char*)(&PresH_Cal1))+2, home->U371.U373, 1);
  V61 &= ~0x4;
  EF32_17();
}

static void BF320_114(void) {
  memcpy(((char*)(&PresH_Cal1))+3, home->U368.U370, 1);
  EF2_0();
  if (!(V61)) {
    display_(1,6,56,
    	 adT,PresH_Cal1,_CVT_21(PresH_Cal1));
  }
}

static void BF320_115(void) {
  memcpy(&PresH_Cal2, home->U365.U367, 1);
  V63 &= ~0x1;
  EF32_19();
}

static void BF320_116(void) {
  memcpy(((char*)(&PresH_Cal2))+1, home->U362.U364, 1);
  V63 &= ~0x2;
  EF2_0();
}

static void BF320_117(void) {
  memcpy(&PresE_F11, home->U20.U23, 3);
  V34 &= ~0x1;
  EF32_21();
  display_(0,16,55,
  	 vdc_chan,home->U27.VoltM_F11,_CVT_17(home->U27.VoltM_F11));
  display_(0,17,55,
  	 vdc_chan,home->U20.VoltB_F11,_CVT_17(home->U20.VoltB_F11));
}

static void BF320_118(void) {
  memcpy(((char*)(&PresH_Cal2))+2, home->U359.U361, 1);
  V63 &= ~0x4;
  EF2_0();
}

static void BF320_120(void) {
  memcpy(((char*)(&PresH_Cal2))+3, home->U356.U358, 1);
  EF2_0();
  if (!(V63)) {
    display_(1,7,56,
    	 adT,PresH_Cal2,_CVT_21(PresH_Cal2));
  }
}

static void BF320_121(void) {
  memcpy(((char*)(&PresE_5))+3, home->U9.U11, 1);
  EF8_1();
  if (!(V17)) {
    {
      rtg_report( ecdMSprs_rtg[ ecdMSprs_rtginc ], dtime() - Injection_rtgbt, PresE_5);
    }
  }
  if (!(V74)) {
    display_(2,19,8,			
    	 adT,PresE_5,_CVT_21(PresE_5));
  }
  display_(2,23,12,			
  	 adT,home->U9.PresBP_5,_CVT_21(home->U9.PresBP_5));
  display_(2,26,20,
  
  	
  	 adT,home->U92.PresMS1,_CVT_21(home->U92.PresMS1));
  display_(2,29,20,			
  	 adT,home->U105.PresMS2,_CVT_21(home->U105.PresMS2));
}

static void BF320_122(void) {
  memcpy(&PresH_CO2, home->U317.U319, 1);
  V71 &= ~0x1;
  EF2_0();
}

static void BF320_124(void) {
  memcpy(((char*)(&PresH_CO2))+1, home->U314.U316, 1);
  V71 &= ~0x2;
  EF2_0();
}

static void BF320_126(void) {
  memcpy(((char*)(&PresH_CO2))+2, home->U311.U313, 1);
  V71 &= ~0x4;
  EF2_0();
}

static void BF320_130(void) {
  memcpy(((char*)(&PresH_CO2))+3, home->U308.U310, 1);
  EF2_0();
  if (!(V71)) {
    display_(1,11,56,
    
    	 adT,PresH_CO2,_CVT_21(PresH_CO2));
  }
}

static void BF320_132(void) {
  memcpy(&PresH_He, home->U389.U391, 1);
  V59 &= ~0x1;
  EF2_0();
}

static void BF320_134(void) {
  memcpy(((char*)(&PresH_He))+1, home->U386.U388, 1);
  V59 &= ~0x2;
  EF2_0();
}

static void BF320_135(void) {
  memcpy(((char*)(&PresH_He))+2, home->U383.U385, 1);
  V59 &= ~0x4;
  EF32_7();
}

static void BF320_136(void) {
  memcpy(((char*)(&PresH_He))+3, home->U380.U382, 1);
  EF2_0();
  if (!(V59)) {
    display_(1,5,56,
    	 adT,PresH_He,_CVT_21(PresH_He));
  }
}

static void BF320_137(void) {
  memcpy(&PresH_N2, home->U401.U403, 1);
  V57 &= ~0x1;
  EF32_9();
}

static void BF320_138(void) {
  memcpy(((char*)(&PresH_N2))+1, home->U398.U400, 1);
  V57 &= ~0x2;
  EF2_0();
}

static void BF320_139(void) {
  memcpy(((char*)(&PresH_N2))+2, home->U395.U397, 1);
  V57 &= ~0x4;
  EF32_11();
}

static void BF320_140(void) {
  memcpy(((char*)(&PresH_N2))+3, home->U392.U394, 1);
  EF2_0();
  if (!(V57)) {
    display_(1,4,56,
    	 adT,PresH_N2,_CVT_21(PresH_N2));
  }
}

static void BF320_141(void) {
  memcpy(&PresH_N2O, home->U329.U331, 1);
  V69 &= ~0x1;
  EF32_13();
}

static void BF320_142(void) {
  memcpy(((char*)(&PresH_N2O))+1, home->U326.U328, 1);
  V69 &= ~0x2;
  EF2_0();
}

static void BF320_143(void) {
  memcpy(((char*)(&PresH_N2O))+2, home->U323.U325, 1);
  V69 &= ~0x4;
  EF32_15();
}

static void BF320_144(void) {
  memcpy(((char*)(&PresH_N2O))+3, home->U320.U322, 1);
  EF2_0();
  if (!(V69)) {
    display_(1,10,56,
    	 adT,PresH_N2O,_CVT_21(PresH_N2O));
  }
}

static void BF320_145(void) {
  memcpy(&PresH_PAN, home->U353.U355, 1);
  V65 &= ~0x1;
  EF32_17();
}

static void BF320_146(void) {
  memcpy(((char*)(&PresH_PAN))+1, home->U350.U352, 1);
  V65 &= ~0x2;
  EF2_0();
}

static void BF320_147(void) {
  memcpy(((char*)(&PresH_PAN))+2, home->U347.U349, 1);
  V65 &= ~0x4;
  EF32_19();
}

static void BF320_148(void) {
  memcpy(((char*)(&PresH_PAN))+3, home->U344.U346, 1);
  EF2_0();
  if (!(V65)) {
    display_(1,8,56,
    	 adT,PresH_PAN,_CVT_21(PresH_PAN));
  }
}

static void BF320_149(void) {
  EF64_21();
  display_(0,17,20,
  	 vdc_chan,home->U9.VoltM_SF6,_CVT_17(home->U9.VoltM_SF6));
  display_(0,18,20,
  	 vdc_chan,home->U24.VoltB_SF6,_CVT_17(home->U24.VoltB_SF6));
}

static void BF320_150(void) {
  memcpy(&PresH_ZA, home->U341.U343, 1);
  V67 &= ~0x1;
  EF2_0();
}

static void BF320_152(void) {
  memcpy(((char*)(&PresH_ZA))+1, home->U338.U340, 1);
  V67 &= ~0x2;
  EF2_0();
}

static void BF320_154(void) {
  memcpy(((char*)(&PresH_ZA))+2, home->U335.U337, 1);
  V67 &= ~0x4;
  EF2_0();
}

static void BF320_156(void) {
  memcpy(((char*)(&PresH_ZA))+3, home->U332.U334, 1);
  EF2_0();
  if (!(V67)) {
    display_(1,9,56,
    	 adT,PresH_ZA,_CVT_21(PresH_ZA));
  }
}

static void BF320_167(void) {
  memcpy(&PresL_Cal1, home->U473.U475, 1);
  V62 &= ~0x1;
  EF32_7();
}

static void BF320_168(void) {
  memcpy(((char*)(&PresL_Cal1))+1, home->U470.U472, 1);
  V62 &= ~0x2;
  EF2_0();
}

static void BF320_169(void) {
  memcpy(((char*)(&PresL_Cal1))+2, home->U467.U469, 1);
  V62 &= ~0x4;
  EF32_9();
}

static void BF320_170(void) {
  memcpy(((char*)(&PresL_Cal1))+3, home->U464.U466, 1);
  EF2_0();
  if (!(V62)) {
    display_(1,6,64,
    	 adT,PresL_Cal1,_CVT_21(PresL_Cal1));
  }
}

static void BF320_171(void) {
  memcpy(&PresL_Cal2, home->U461.U463, 1);
  V64 &= ~0x1;
  EF32_11();
}

static void BF320_172(void) {
  memcpy(((char*)(&PresL_Cal2))+1, home->U458.U460, 1);
  V64 &= ~0x2;
  EF2_0();
}

static void BF320_173(void) {
  memcpy(((char*)(&PresL_Cal2))+2, home->U455.U457, 1);
  V64 &= ~0x4;
  EF32_13();
}

static void BF320_174(void) {
  memcpy(((char*)(&PresL_Cal2))+3, home->U452.U454, 1);
  EF2_0();
  if (!(V64)) {
    display_(1,7,64,
    	 adT,PresL_Cal2,_CVT_21(PresL_Cal2));
  }
}

static void BF320_175(void) {
  memcpy(&PresL_CO2, home->U413.U415, 1);
  V72 &= ~0x1;
  EF32_15();
}

static void BF320_176(void) {
  memcpy(((char*)(&PresL_CO2))+1, home->U410.U412, 1);
  V72 &= ~0x2;
  EF2_0();
}

static void BF320_177(void) {
  memcpy(((char*)(&PresL_CO2))+2, home->U407.U409, 1);
  V72 &= ~0x4;
  EF32_17();
}

static void BF320_178(void) {
  memcpy(((char*)(&PresL_CO2))+3, home->U404.U406, 1);
  EF2_0();
  if (!(V72)) {
    display_(1,11,64,
    
    	 adT,PresL_CO2,_CVT_21(PresL_CO2));
  }
}

static void BF320_179(void) {
  memcpy(&PresL_He, home->U485.U487, 1);
  V60 &= ~0x1;
  EF32_19();
}

static void BF320_180(void) {
  memcpy(((char*)(&PresL_He))+1, home->U482.U484, 1);
  V60 &= ~0x2;
  EF2_0();
}

static void BF320_181(void) {
  memcpy(&VoltM_PAN, home->U27.U30, 3);
  V38 &= ~0x1;
  EF32_21();
  display_(0,27,55,
  	 vdc_chan,home->U35.VoltB_PAN,_CVT_17(home->U35.VoltB_PAN));
  display_(0,28,55,
  	 vdc_chan,home->U58.VoltE_PAN,_CVT_17(home->U58.VoltE_PAN));
}

static void BF320_182(void) {
  memcpy(((char*)(&PresL_He))+2, home->U479.U481, 1);
  V60 &= ~0x4;
  EF2_0();
}

static void BF320_184(void) {
  memcpy(((char*)(&PresL_He))+3, home->U476.U478, 1);
  EF2_0();
  if (!(V60)) {
    display_(1,5,64,
    	 adT,PresL_He,_CVT_21(PresL_He));
  }
}

static void BF320_185(void) {
  memcpy(&PresE_CO, home->U17.U19, 3);
  memcpy(((char*)(&VoltBP_CO))+2, home->U2.U4, 2); {
    V36 &= ~0x1;
    V15 &= ~0x2;
  }
  EF8_1();
  display_(0,26,20,
  	 vdc_chan,home->U17.VoltM_CO,_CVT_17(home->U17.VoltM_CO));
  display_(0,27,20,
  	 vdc_chan,home->U12.VoltB_CO,_CVT_17(home->U12.VoltB_CO));
  if (!(V35)) {
    display_(0,28,20,
    	 vdc_chan,VoltBP_CO,_CVT_17(VoltBP_CO));
  }
}

static void BF320_186(void) {
  memcpy(&PresL_N2, home->U497.U499, 1);
  V58 &= ~0x1;
  EF2_0();
}

static void BF320_188(void) {
  memcpy(((char*)(&PresL_N2))+1, home->U494.U496, 1);
  V58 &= ~0x2;
  EF2_0();
}

static void BF320_190(void) {
  memcpy(((char*)(&PresL_N2))+2, home->U491.U493, 1);
  V58 &= ~0x4;
  EF2_0();
}

static void BF320_194(void) {
  memcpy(((char*)(&PresL_N2))+3, home->U488.U490, 1);
  EF2_0();
  if (!(V58)) {
    display_(1,4,64,
    	 adT,PresL_N2,_CVT_21(PresL_N2));
  }
}

static void BF320_196(void) {
  memcpy(&PresL_N2O, home->U425.U427, 1);
  V70 &= ~0x1;
  EF2_0();
}

static void BF320_198(void) {
  memcpy(((char*)(&PresL_N2O))+1, home->U422.U424, 1);
  V70 &= ~0x2;
  EF2_0();
}

static void BF320_199(void) {
  memcpy(((char*)(&PresL_N2O))+2, home->U419.U421, 1);
  V70 &= ~0x4;
  EF32_7();
}

static void BF320_200(void) {
  memcpy(((char*)(&PresL_N2O))+3, home->U416.U418, 1);
  EF2_0();
  if (!(V70)) {
    display_(1,10,64,
    	 adT,PresL_N2O,_CVT_21(PresL_N2O));
  }
}

static void BF320_201(void) {
  memcpy(&PresL_PAN, home->U449.U451, 1);
  V66 &= ~0x1;
  EF32_9();
}

static void BF320_202(void) {
  memcpy(((char*)(&PresL_PAN))+1, home->U446.U448, 1);
  V66 &= ~0x2;
  EF2_0();
}

static void BF320_203(void) {
  memcpy(((char*)(&PresL_PAN))+2, home->U443.U445, 1);
  V66 &= ~0x4;
  EF32_11();
}

static void BF320_204(void) {
  memcpy(((char*)(&PresL_PAN))+3, home->U440.U442, 1);
  EF2_0();
  if (!(V66)) {
    display_(1,8,64,
    	 adT,PresL_PAN,_CVT_21(PresL_PAN));
  }
}

static void BF320_205(void) {
  memcpy(&PresL_ZA, home->U437.U439, 1);
  V68 &= ~0x1;
  EF32_13();
}

static void BF320_206(void) {
  memcpy(((char*)(&PresL_ZA))+1, home->U434.U436, 1);
  V68 &= ~0x2;
  EF2_0();
}

static void BF320_207(void) {
  memcpy(((char*)(&PresL_ZA))+2, home->U431.U433, 1);
  V68 &= ~0x4;
  EF32_15();
}

static void BF320_208(void) {
  memcpy(((char*)(&PresL_ZA))+3, home->U428.U430, 1);
  EF2_0();
  if (!(V68)) {
    display_(1,9,64,
    	 adT,PresL_ZA,_CVT_21(PresL_ZA));
  }
}

static void BF320_209(void) {
  memcpy(&PresMS1sp, home->U149.U151, 1);
  V77 &= ~0x1;
  EF32_17();
}

static void BF320_210(void) {
  memcpy(((char*)(&PresMS1sp))+1, home->U146.U148, 1);
  V77 &= ~0x2;
  EF2_0();
}

static void BF320_211(void) {
  memcpy(((char*)(&PresMS1sp))+2, home->U143.U145, 1);
  V77 &= ~0x4;
  EF32_19();
}

static void BF320_212(void) {
  memcpy(((char*)(&PresMS1sp))+3, home->U140.U142, 1);
  EF2_0();
  if (!(V77)) {
    display_(2,27,20,
    	 dacMSpr,PresMS1sp,_CVT_13(PresMS1sp));
  }
}

static void BF320_213(void) {
  EF64_21();
  if (!(V14)) {
    {
      rtg_report( ecdSF6prs_rtg[ ecdSF6prs_rtginc ], dtime() - Injection_rtgbt, home->U9.PresE_SF6);
    }
  }
  display_(0,19,7,
  	 adT,home->U6.PresBP_SF6,_CVT_21(home->U6.PresBP_SF6));
  display_(0,20,7,
  	 adT,home->U9.PresE_SF6,_CVT_21(home->U9.PresE_SF6));
}

static void BF320_214(void) {
  memcpy(&PresMS2sp, home->U161.U163, 1);
  V79 &= ~0x1;
  EF2_0();
}

static void BF320_216(void) {
  memcpy(((char*)(&PresMS2sp))+1, home->U158.U160, 1);
  V79 &= ~0x2;
  EF2_0();
}

static void BF320_218(void) {
  memcpy(((char*)(&PresMS2sp))+2, home->U155.U157, 1);
  V79 &= ~0x4;
  EF2_0();
}

static void BF320_220(void) {
  memcpy(((char*)(&PresMS2sp))+3, home->U152.U154, 1);
  EF2_0();
  if (!(V79)) {
    display_(2,30,20,
    	 dacMSpr,PresMS2sp,_CVT_13(PresMS2sp));
  }
}

static void BF320_231(void) {
  memcpy(&Temp_COsl, home->U521.U523, 1);
  V40 &= ~0x1;
  EF32_7();
}

static void BF320_232(void) {
  memcpy(((char*)(&Temp_COsl))+1, home->U518.U520, 1);
  V40 &= ~0x2;
  EF2_0();
}

static void BF320_233(void) {
  memcpy(((char*)(&Temp_COsl))+2, home->U515.U517, 1);
  V40 &= ~0x4;
  EF32_9();
}

static void BF320_234(void) {
  memcpy(((char*)(&Temp_COsl))+3, home->U512.U514, 1);
  EF2_0();
  if (!(V40)) {
    display_(1,5,18,
    	 adT,Temp_COsl,_CVT_21(Temp_COsl));
  }
}

static void BF320_235(void) {
  memcpy(&Temp_elect, home->U557.U559, 1);
  V43 &= ~0x1;
  EF32_11();
}

static void BF320_236(void) {
  memcpy(((char*)(&Temp_elect))+1, home->U554.U556, 1);
  V43 &= ~0x2;
  EF2_0();
}

static void BF320_237(void) {
  memcpy(((char*)(&Temp_elect))+2, home->U551.U553, 1);
  V43 &= ~0x4;
  EF32_13();
}

static void BF320_238(void) {
  memcpy(((char*)(&Temp_elect))+3, home->U548.U550, 1);
  EF2_0();
  if (!(V43)) {
    display_(1,8,18,
    	 adT,Temp_elect,_CVT_21(Temp_elect));
  }
}

static void BF320_239(void) {
  memcpy(&Temp_F11sl, home->U509.U511, 1);
  V39 &= ~0x1;
  EF32_15();
}

static void BF320_240(void) {
  memcpy(((char*)(&Temp_F11sl))+1, home->U506.U508, 1);
  V39 &= ~0x2;
  EF2_0();
}

static void BF320_241(void) {
  memcpy(((char*)(&Temp_F11sl))+2, home->U503.U505, 1);
  V39 &= ~0x4;
  EF32_17();
}

static void BF320_242(void) {
  memcpy(((char*)(&Temp_F11sl))+3, home->U500.U502, 1);
  EF2_0();
  if (!(V39)) {
    display_(1,4,18,
    	
    	 adT,Temp_F11sl,_CVT_21(Temp_F11sl));
  }
}

static void BF320_243(void) {
  memcpy(&Temp_GasBot, home->U581.U583, 1);
  V46 &= ~0x1;
  EF32_19();
}

static void BF320_244(void) {
  memcpy(((char*)(&Temp_GasBot))+1, home->U578.U580, 1);
  V46 &= ~0x2;
  EF2_0();
}

static void BF320_245(void) {
  memcpy(&PresSrc_PAN, home->U48.U51, 2);
  memcpy(((char*)(&VoltM_PAN))+3, home->U43.U46, 1);
  V32 &= ~0x1;
  EF32_21();
  if (!(V16)) {
    {
      rtg_report( ecdPANprs_rtg[ ecdPANprs_rtginc ], dtime() - Injection_rtgbt, home->U31.PresE_PAN);
    }
  }
  display_(0,10,25, 		
  	 adT_flow,home->U43.FlowSrc_PAN,_CVT_19(home->U43.FlowSrc_PAN));
  if (!(V38)) {
    display_(0,26,55,
    	 vdc_chan,VoltM_PAN,_CVT_17(VoltM_PAN));
  }
  display_(0,28,42, 
  	 adT,home->U31.PresE_PAN,_CVT_21(home->U31.PresE_PAN));
}

static void BF320_246(void) {
  memcpy(((char*)(&Temp_GasBot))+2, home->U575.U577, 1);
  V46 &= ~0x4;
  EF2_0();
}

static void BF320_248(void) {
  memcpy(((char*)(&Temp_GasBot))+3, home->U572.U574, 1);
  EF2_0();
  if (!(V46)) {
    display_(1,13,18,	
    	 adT,Temp_GasBot,_CVT_21(Temp_GasBot));
  }
}

static void BF320_249(void) {
  memcpy(((char*)(&PresE_CO))+3, home->U0.U1, 1);
  EF8_1();
  if (!(V15)) {
    {
      rtg_report( ecdCOprs_rtg[ ecdCOprs_rtginc ], dtime() - Injection_rtgbt, PresE_CO);
    }
  }
  display_(0,26,7,
  	
  	 adT_flow,home->U0.FlowM_CO,_CVT_19(home->U0.FlowM_CO));
  display_(0,27,7,
  	 adT_flow,home->U0.FlowB_CO,_CVT_19(home->U0.FlowB_CO));
  display_(0,28,7,
  	 adT,home->U0.PresBP_CO,_CVT_21(home->U0.PresBP_CO));
  if (!(V36)) {
    display_(0,29,7,
    	 adT,PresE_CO,_CVT_21(PresE_CO));
  }
}

static void BF320_250(void) {
  memcpy(&Temp_GSVbo, home->U545.U547, 1);
  V42 &= ~0x1;
  EF2_0();
}

static void BF320_252(void) {
  memcpy(((char*)(&Temp_GSVbo))+1, home->U542.U544, 1);
  V42 &= ~0x2;
  EF2_0();
}

static void BF320_254(void) {
  memcpy(((char*)(&Temp_GSVbo))+2, home->U539.U541, 1);
  V42 &= ~0x4;
  EF2_0();
}

static void BF320_258(void) {
  memcpy(((char*)(&Temp_GSVbo))+3, home->U536.U538, 1);
  EF2_0();
  if (!(V42)) {
    display_(1,7,18,
    	 adT,Temp_GSVbo,_CVT_21(Temp_GSVbo));
  }
}

static void BF320_260(void) {
  memcpy(&Temp_PANlmp, home->U593.U595, 1);
  V45 &= ~0x1;
  EF2_0();
}

static void BF320_262(void) {
  memcpy(((char*)(&Temp_PANlmp))+1, home->U590.U592, 1);
  V45 &= ~0x2;
  EF2_0();
}

static void BF320_263(void) {
  memcpy(((char*)(&Temp_PANlmp))+2, home->U587.U589, 1);
  V45 &= ~0x4;
  EF32_7();
}

static void BF320_264(void) {
  memcpy(((char*)(&Temp_PANlmp))+3, home->U584.U586, 1);
  EF2_0();
  if (!(V45)) {
    display_(1,12,18,	
    	 adT,Temp_PANlmp,_CVT_21(Temp_PANlmp));
  }
}

static void BF320_265(void) {
  memcpy(&Temp_PANsl, home->U533.U535, 1);
  V41 &= ~0x1;
  EF32_9();
}

static void BF320_266(void) {
  memcpy(((char*)(&Temp_PANsl))+1, home->U530.U532, 1);
  V41 &= ~0x2;
  EF2_0();
}

static void BF320_267(void) {
  memcpy(((char*)(&Temp_PANsl))+2, home->U527.U529, 1);
  V41 &= ~0x4;
  EF32_11();
}

static void BF320_268(void) {
  memcpy(((char*)(&Temp_PANsl))+3, home->U524.U526, 1);
  EF2_0();
  if (!(V41)) {
    display_(1,6,18,
    	 adT,Temp_PANsl,_CVT_21(Temp_PANsl));
  }
}

static void BF320_269(void) {
  memcpy(&Temp_stack, home->U569.U571, 1);
  V44 &= ~0x1;
  EF32_13();
}

static void BF320_270(void) {
  memcpy(((char*)(&Temp_stack))+1, home->U566.U568, 1);
  V44 &= ~0x2;
  EF2_0();
}

static void BF320_271(void) {
  memcpy(((char*)(&Temp_stack))+2, home->U563.U565, 1);
  V44 &= ~0x4;
  EF32_15();
}

static void BF320_272(void) {
  memcpy(((char*)(&Temp_stack))+3, home->U560.U562, 1);
  EF2_0();
  if (!(V44)) {
    display_(1,9,18,
    	 adT,Temp_stack,_CVT_21(Temp_stack));
  }
}

static void BF320_273(void) {
  memcpy(&Trap1_re, home->U185.U187, 1);
  V81 &= ~0x1;
  EF32_17();
}

static void BF320_274(void) {
  memcpy(((char*)(&Trap1_re))+1, home->U182.U184, 1);
  V81 &= ~0x2;
  EF2_0();
}

static void BF320_275(void) {
  memcpy(((char*)(&Trap1_re))+2, home->U179.U181, 1);
  V81 &= ~0x4;
  EF32_19();
}

static void BF320_276(void) {
  memcpy(((char*)(&Trap1_re))+3, home->U176.U178, 1);
  EF2_0();
  if (!(V81)) {
    display_(2,27,49,
    	 adT,Trap1_re,_CVT_21(Trap1_re));
  }
}

static void BF320_277(void) {
  EF64_21();
  display_(0,17,7,
  
  	 adT_flow,home->U2.FlowM_SF6,_CVT_19(home->U2.FlowM_SF6));
  display_(0,18,7,
  	 adT_flow,home->U6.FlowB_SF6,_CVT_19(home->U6.FlowB_SF6));
}

static void BF320_278(void) {
  memcpy(&Trap1_set, home->U173.U175, 1);
  V82 &= ~0x1;
  EF2_0();
}

static void BF320_280(void) {
  memcpy(((char*)(&Trap1_set))+1, home->U170.U172, 1);
  V82 &= ~0x2;
  EF2_0();
}

static void BF320_282(void) {
  memcpy(((char*)(&Trap1_set))+2, home->U167.U169, 1);
  V82 &= ~0x4;
  EF2_0();
}

static void BF320_284(void) {
  memcpy(((char*)(&Trap1_set))+3, home->U164.U166, 1);
  EF2_0();
  if (!(V82)) {
    display_(2,27,62,
    
    	
    	 adT,Trap1_set,_CVT_21(Trap1_set));
  }
}

static void BF320_286(void) {
  memcpy(&Trap2_re, home->U209.U211, 1);
  V83 &= ~0x1;
  EF2_0();
}

static void BF320_290(void) {
  memcpy(((char*)(&Trap2_re))+1, home->U206.U208, 1);
  V83 &= ~0x2;
  EF2_0();
}

static void BF320_292(void) {
  memcpy(((char*)(&Trap2_re))+2, home->U203.U205, 1);
  V83 &= ~0x4;
  EF2_0();
}

static void BF320_294(void) {
  memcpy(((char*)(&Trap2_re))+3, home->U200.U202, 1);
  EF2_0();
  if (!(V83)) {
    display_(2,31,49,
    	 adT,Trap2_re,_CVT_21(Trap2_re));
  }
}

static void BF320_295(void) {
  memcpy(&Trap2_set, home->U197.U199, 1);
  V84 &= ~0x1;
  EF32_7();
}

static void BF320_296(void) {
  memcpy(((char*)(&Trap2_set))+1, home->U194.U196, 1);
  V84 &= ~0x2;
  EF2_0();
}

static void BF320_297(void) {
  memcpy(((char*)(&Trap2_set))+2, home->U191.U193, 1);
  V84 &= ~0x4;
  EF32_9();
}

static void BF320_298(void) {
  memcpy(((char*)(&Trap2_set))+3, home->U188.U190, 1);
  EF2_0();
  if (!(V84)) {
    display_(2,31,62,
    	 adT,Trap2_set,_CVT_21(Trap2_set));
  }
}

static void BF320_299(void) {
  memcpy(&VoltBP_PAN, home->U137.U139, 1);
  V30 &= ~0x1;
  EF32_11();
}

static void BF320_300(void) {
  memcpy(((char*)(&VoltBP_PAN))+1, home->U134.U136, 1);
  V30 &= ~0x2;
  EF2_0();
}

static void BF320_301(void) {
  memcpy(((char*)(&VoltBP_PAN))+2, home->U131.U133, 1);
  V30 &= ~0x4;
  EF32_13();
}

static void BF320_302(void) {
  memcpy(((char*)(&VoltBP_PAN))+3, home->U128.U130, 1);
  EF2_0();
  if (!(V30)) {
    display_(0,6,24,
    	 vdc_chan,VoltBP_PAN,_CVT_17(VoltBP_PAN));
  }
}

static void BF320_309(void) {
  memcpy(((char*)(&PresSrc_PAN))+2, home->U35.U38, 2);
  EF32_21();
  if (!(V32)) {
    display_(0,10,32,			
    	 adT,PresSrc_PAN,_CVT_21(PresSrc_PAN));
  }
  display_(0,26,42,
  
  	 adT,home->U12.Pres1_PAN,_CVT_21(home->U12.Pres1_PAN));
  display_(0,27,42,			
  	 adT,home->U2.Pres2_PAN,_CVT_21(home->U2.Pres2_PAN));
}

static void BF320_313(void) {
  memcpy(((char*)(&PresE_F11))+3, home->U6.U8, 1);
  EF8_1();
  display_(0,16,42,
  
  	 adT_flow,home->U40.FlowM_F11,_CVT_19(home->U40.FlowM_F11));
  display_(0,17,42,
  	 adT_flow,home->U92.FlowB_F11,_CVT_19(home->U92.FlowB_F11));
  display_(0,18,42,
  	 adT,home->U6.PresBP_F11,_CVT_21(home->U6.PresBP_F11));
  if (!(V34)) {
    display_(0,19,42,
    	 adT,PresE_F11,_CVT_21(PresE_F11));
  }
}

static void (*efuncs[320])() = {
  BF32_0,
  BF32_1,
  BF320_2,
  BF32_3,
  BF320_4,
  BF32_5,
  BF320_6,
  BF320_7,
  BF320_8,
  BF320_9,
  BF320_10,
  BF320_11,
  BF320_12,
  BF320_13,
  BF320_14,
  BF320_15,
  BF320_16,
  BF320_17,
  BF320_18,
  BF320_19,
  BF320_20,
  BF320_21,
  BF320_22,
  BF64_23,
  BF320_24,
  BF64_25,
  BF320_26,
  BF64_27,
  BF320_28,
  BF64_29,
  BF320_30,
  BF64_31,
  BF32_0,
  BF32_1,
  BF320_34,
  BF32_3,
  BF320_36,
  BF32_5,
  BF320_38,
  BF320_39,
  BF320_40,
  BF320_41,
  BF320_42,
  BF320_43,
  BF320_44,
  BF320_45,
  BF320_46,
  BF320_47,
  BF320_48,
  BF320_49,
  BF320_50,
  BF320_51,
  BF320_52,
  BF320_53,
  BF320_54,
  BF64_55,
  BF320_56,
  BF320_57,
  BF320_58,
  BF64_59,
  BF320_60,
  BF64_61,
  BF320_62,
  BF64_63,
  BF32_0,
  BF32_1,
  BF320_66,
  BF32_3,
  BF320_68,
  BF32_5,
  BF320_70,
  BF320_71,
  BF320_72,
  BF320_73,
  BF320_74,
  BF320_75,
  BF320_76,
  BF320_77,
  BF320_78,
  BF320_79,
  BF320_80,
  BF320_81,
  BF320_82,
  BF320_83,
  BF320_84,
  BF320_85,
  BF320_86,
  BF64_23,
  BF320_88,
  BF64_25,
  BF320_90,
  BF64_27,
  BF320_92,
  BF64_29,
  BF320_94,
  BF64_31,
  BF32_0,
  BF32_1,
  BF320_98,
  BF32_3,
  BF320_100,
  BF32_5,
  BF320_102,
  BF320_103,
  BF320_104,
  BF320_105,
  BF320_106,
  BF320_107,
  BF320_108,
  BF320_109,
  BF320_110,
  BF320_111,
  BF320_112,
  BF320_113,
  BF320_114,
  BF320_115,
  BF320_116,
  BF320_117,
  BF320_118,
  BF64_55,
  BF320_120,
  BF320_121,
  BF320_122,
  BF64_59,
  BF320_124,
  BF64_61,
  BF320_126,
  BF64_63,
  BF32_0,
  BF32_1,
  BF320_130,
  BF32_3,
  BF320_132,
  BF32_5,
  BF320_134,
  BF320_135,
  BF320_136,
  BF320_137,
  BF320_138,
  BF320_139,
  BF320_140,
  BF320_141,
  BF320_142,
  BF320_143,
  BF320_144,
  BF320_145,
  BF320_146,
  BF320_147,
  BF320_148,
  BF320_149,
  BF320_150,
  BF64_23,
  BF320_152,
  BF64_25,
  BF320_154,
  BF64_27,
  BF320_156,
  BF64_29,
  EF2_0,
  BF64_31,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  BF320_167,
  BF320_168,
  BF320_169,
  BF320_170,
  BF320_171,
  BF320_172,
  BF320_173,
  BF320_174,
  BF320_175,
  BF320_176,
  BF320_177,
  BF320_178,
  BF320_179,
  BF320_180,
  BF320_181,
  BF320_182,
  BF64_55,
  BF320_184,
  BF320_185,
  BF320_186,
  BF64_59,
  BF320_188,
  BF64_61,
  BF320_190,
  BF64_63,
  BF32_0,
  BF32_1,
  BF320_194,
  BF32_3,
  BF320_196,
  BF32_5,
  BF320_198,
  BF320_199,
  BF320_200,
  BF320_201,
  BF320_202,
  BF320_203,
  BF320_204,
  BF320_205,
  BF320_206,
  BF320_207,
  BF320_208,
  BF320_209,
  BF320_210,
  BF320_211,
  BF320_212,
  BF320_213,
  BF320_214,
  BF64_23,
  BF320_216,
  BF64_25,
  BF320_218,
  BF64_27,
  BF320_220,
  BF64_29,
  EF2_0,
  BF64_31,
  BF32_0,
  BF32_1,
  EF2_0,
  BF32_3,
  EF2_0,
  BF32_5,
  EF2_0,
  BF320_231,
  BF320_232,
  BF320_233,
  BF320_234,
  BF320_235,
  BF320_236,
  BF320_237,
  BF320_238,
  BF320_239,
  BF320_240,
  BF320_241,
  BF320_242,
  BF320_243,
  BF320_244,
  BF320_245,
  BF320_246,
  BF64_55,
  BF320_248,
  BF320_249,
  BF320_250,
  BF64_59,
  BF320_252,
  BF64_61,
  BF320_254,
  BF64_63,
  BF32_0,
  BF32_1,
  BF320_258,
  BF32_3,
  BF320_260,
  BF32_5,
  BF320_262,
  BF320_263,
  BF320_264,
  BF320_265,
  BF320_266,
  BF320_267,
  BF320_268,
  BF320_269,
  BF320_270,
  BF320_271,
  BF320_272,
  BF320_273,
  BF320_274,
  BF320_275,
  BF320_276,
  BF320_277,
  BF320_278,
  BF64_23,
  BF320_280,
  BF64_25,
  BF320_282,
  BF64_27,
  BF320_284,
  BF64_29,
  BF320_286,
  BF64_31,
  BF32_0,
  BF32_1,
  BF320_290,
  BF32_3,
  BF320_292,
  BF32_5,
  BF320_294,
  BF320_295,
  BF320_296,
  BF320_297,
  BF320_298,
  BF320_299,
  BF320_300,
  BF320_301,
  BF320_302,
  EF32_15,
  EF2_0,
  EF32_17,
  EF2_0,
  EF32_19,
  EF2_0,
  BF320_309,
  EF2_0,
  BF64_55,
  EF2_0,
  BF320_313,
  EF2_0,
  BF64_59,
  EF2_0,
  BF64_61,
  EF2_0,
  BF64_63
};

static void IVF32_1(void) { {
    V19 |= 0x2;
    V18 |= 0x2;
    V9 |= 0x2;
  }
}
static void IVF320_2(void) {
  V33 |= 0x1;
}
static void IVF32_3(void) { {
    V73 |= 0x1;
    V19 |= 0x4;
    V9 |= 0x1;
  }
}
static void IVF320_4(void) {
  V31 |= 0x1;
}
static void IVF320_6(void) {
  V31 |= 0x2;
}
static void IVF320_7(void) {
  V31 |= 0x4;
}
static void IVF320_9(void) {
  V28 |= 0x1;
}
static void IVF320_10(void) {
  V28 |= 0x2;
}
static void IVF320_11(void) {
  V28 |= 0x4;
}
static void IVF320_13(void) {
  V75 |= 0x1;
}
static void IVF320_14(void) {
  V75 |= 0x2;
}
static void IVF320_15(void) {
  V75 |= 0x4;
}
static void IVF320_17(void) {
  V78 |= 0x1;
}
static void IVF320_18(void) {
  V78 |= 0x2;
}
static void IVF320_19(void) {
  V78 |= 0x4;
}
static void IVF64_21(void) {
  V92 |= 0x1;
}
static void IVF320_21(void) {IVF64_21(); {
    V76 |= 0x1;
    V33 |= 0x2;
  }
}
static void IVF320_22(void) {
  V80 |= 0x1;
}
static void IVF64_23(void) {
  V85 |= 0x1;
}
static void IVF320_24(void) {
  V80 |= 0x2;
}
static void IVF64_25(void) {
  V86 |= 0x1;
}
static void IVF320_26(void) {
  V80 |= 0x4;
}
static void IVF64_27(void) {
  V93 |= 0x1;
}
static void IVF64_29(void) {
  V90 |= 0x1;
}
static void IVF320_30(void) {
  V37 |= 0x1;
}
static void IVF64_31(void) {
  V87 |= 0x1;
}
static void IVF320_34(void) {
  V37 |= 0x2;
}
static void IVF320_36(void) {
  V37 |= 0x4;
}
static void IVF320_39(void) {
  V54 |= 0x1;
}
static void IVF320_40(void) {
  V54 |= 0x2;
}
static void IVF320_41(void) {
  V54 |= 0x4;
}
static void IVF320_43(void) {
  V55 |= 0x1;
}
static void IVF320_44(void) {
  V55 |= 0x2;
}
static void IVF320_45(void) {
  V55 |= 0x4;
}
static void IVF320_47(void) {
  V53 |= 0x1;
}
static void IVF320_48(void) {
  V53 |= 0x2;
}
static void IVF320_49(void) {
  V53 |= 0x4;
}
static void IVF320_51(void) {
  V51 |= 0x1;
}
static void IVF320_52(void) {
  V51 |= 0x2;
}
static void IVF320_53(void) {
  V35 |= 0x1;
}
static void IVF320_54(void) {
  V51 |= 0x4;
}
static void IVF64_55(void) {
  V89 |= 0x1;
}
static void IVF320_57(void) { {
    V74 |= 0x1;
    V17 |= 0x2;
  }
}
static void IVF320_58(void) {
  V52 |= 0x1;
}
static void IVF64_59(void) {
  V91 |= 0x1;
}
static void IVF320_60(void) {
  V52 |= 0x2;
}
static void IVF64_61(void) {
  V88 |= 0x1;
}
static void IVF320_62(void) {
  V52 |= 0x4;
}
static void IVF320_68(void) {
  V49 |= 0x1;
}
static void IVF320_70(void) {
  V49 |= 0x2;
}
static void IVF320_71(void) {
  V49 |= 0x4;
}
static void IVF320_73(void) {
  V50 |= 0x1;
}
static void IVF320_74(void) {
  V50 |= 0x2;
}
static void IVF320_75(void) {
  V50 |= 0x4;
}
static void IVF320_77(void) {
  V47 |= 0x1;
}
static void IVF320_78(void) {
  V47 |= 0x2;
}
static void IVF320_79(void) {
  V47 |= 0x4;
}
static void IVF320_81(void) {
  V48 |= 0x1;
}
static void IVF320_82(void) {
  V48 |= 0x2;
}
static void IVF320_83(void) {
  V48 |= 0x4;
}
static void IVF320_86(void) {
  V56 |= 0x1;
}
static void IVF320_88(void) {
  V56 |= 0x2;
}
static void IVF320_90(void) {
  V56 |= 0x4;
}
static void IVF320_94(void) {
  V26 |= 0x1;
}
static void IVF320_98(void) {
  V26 |= 0x2;
}
static void IVF320_100(void) {
  V26 |= 0x4;
}
static void IVF320_103(void) {
  V27 |= 0x1;
}
static void IVF320_104(void) {
  V27 |= 0x2;
}
static void IVF320_105(void) {
  V27 |= 0x4;
}
static void IVF320_107(void) {
  V29 |= 0x1;
}
static void IVF320_108(void) {
  V29 |= 0x2;
}
static void IVF320_109(void) {
  V29 |= 0x4;
}
static void IVF320_111(void) {
  V61 |= 0x1;
}
static void IVF320_112(void) {
  V61 |= 0x2;
}
static void IVF320_113(void) {
  V61 |= 0x4;
}
static void IVF320_115(void) {
  V63 |= 0x1;
}
static void IVF320_116(void) {
  V63 |= 0x2;
}
static void IVF320_117(void) {
  V34 |= 0x1;
}
static void IVF320_118(void) {
  V63 |= 0x4;
}
static void IVF320_122(void) {
  V71 |= 0x1;
}
static void IVF320_124(void) {
  V71 |= 0x2;
}
static void IVF320_126(void) {
  V71 |= 0x4;
}
static void IVF320_132(void) {
  V59 |= 0x1;
}
static void IVF320_134(void) {
  V59 |= 0x2;
}
static void IVF320_135(void) {
  V59 |= 0x4;
}
static void IVF320_137(void) {
  V57 |= 0x1;
}
static void IVF320_138(void) {
  V57 |= 0x2;
}
static void IVF320_139(void) {
  V57 |= 0x4;
}
static void IVF320_141(void) {
  V69 |= 0x1;
}
static void IVF320_142(void) {
  V69 |= 0x2;
}
static void IVF320_143(void) {
  V69 |= 0x4;
}
static void IVF320_145(void) {
  V65 |= 0x1;
}
static void IVF320_146(void) {
  V65 |= 0x2;
}
static void IVF320_147(void) {
  V65 |= 0x4;
}
static void IVF320_150(void) {
  V67 |= 0x1;
}
static void IVF320_152(void) {
  V67 |= 0x2;
}
static void IVF320_154(void) {
  V67 |= 0x4;
}
static void IVF320_167(void) {
  V62 |= 0x1;
}
static void IVF320_168(void) {
  V62 |= 0x2;
}
static void IVF320_169(void) {
  V62 |= 0x4;
}
static void IVF320_171(void) {
  V64 |= 0x1;
}
static void IVF320_172(void) {
  V64 |= 0x2;
}
static void IVF320_173(void) {
  V64 |= 0x4;
}
static void IVF320_175(void) {
  V72 |= 0x1;
}
static void IVF320_176(void) {
  V72 |= 0x2;
}
static void IVF320_177(void) {
  V72 |= 0x4;
}
static void IVF320_179(void) {
  V60 |= 0x1;
}
static void IVF320_180(void) {
  V60 |= 0x2;
}
static void IVF320_181(void) {
  V38 |= 0x1;
}
static void IVF320_182(void) {
  V60 |= 0x4;
}
static void IVF320_185(void) { {
    V36 |= 0x1;
    V15 |= 0x2;
  }
}
static void IVF320_186(void) {
  V58 |= 0x1;
}
static void IVF320_188(void) {
  V58 |= 0x2;
}
static void IVF320_190(void) {
  V58 |= 0x4;
}
static void IVF320_196(void) {
  V70 |= 0x1;
}
static void IVF320_198(void) {
  V70 |= 0x2;
}
static void IVF320_199(void) {
  V70 |= 0x4;
}
static void IVF320_201(void) {
  V66 |= 0x1;
}
static void IVF320_202(void) {
  V66 |= 0x2;
}
static void IVF320_203(void) {
  V66 |= 0x4;
}
static void IVF320_205(void) {
  V68 |= 0x1;
}
static void IVF320_206(void) {
  V68 |= 0x2;
}
static void IVF320_207(void) {
  V68 |= 0x4;
}
static void IVF320_209(void) {
  V77 |= 0x1;
}
static void IVF320_210(void) {
  V77 |= 0x2;
}
static void IVF320_211(void) {
  V77 |= 0x4;
}
static void IVF320_214(void) {
  V79 |= 0x1;
}
static void IVF320_216(void) {
  V79 |= 0x2;
}
static void IVF320_218(void) {
  V79 |= 0x4;
}
static void IVF320_231(void) {
  V40 |= 0x1;
}
static void IVF320_232(void) {
  V40 |= 0x2;
}
static void IVF320_233(void) {
  V40 |= 0x4;
}
static void IVF320_235(void) {
  V43 |= 0x1;
}
static void IVF320_236(void) {
  V43 |= 0x2;
}
static void IVF320_237(void) {
  V43 |= 0x4;
}
static void IVF320_239(void) {
  V39 |= 0x1;
}
static void IVF320_240(void) {
  V39 |= 0x2;
}
static void IVF320_241(void) {
  V39 |= 0x4;
}
static void IVF320_243(void) {
  V46 |= 0x1;
}
static void IVF320_244(void) {
  V46 |= 0x2;
}
static void IVF320_245(void) {
  V32 |= 0x1;
}
static void IVF320_246(void) {
  V46 |= 0x4;
}
static void IVF320_250(void) {
  V42 |= 0x1;
}
static void IVF320_252(void) {
  V42 |= 0x2;
}
static void IVF320_254(void) {
  V42 |= 0x4;
}
static void IVF320_260(void) {
  V45 |= 0x1;
}
static void IVF320_262(void) {
  V45 |= 0x2;
}
static void IVF320_263(void) {
  V45 |= 0x4;
}
static void IVF320_265(void) {
  V41 |= 0x1;
}
static void IVF320_266(void) {
  V41 |= 0x2;
}
static void IVF320_267(void) {
  V41 |= 0x4;
}
static void IVF320_269(void) {
  V44 |= 0x1;
}
static void IVF320_270(void) {
  V44 |= 0x2;
}
static void IVF320_271(void) {
  V44 |= 0x4;
}
static void IVF320_273(void) {
  V81 |= 0x1;
}
static void IVF320_274(void) {
  V81 |= 0x2;
}
static void IVF320_275(void) {
  V81 |= 0x4;
}
static void IVF320_278(void) {
  V82 |= 0x1;
}
static void IVF320_280(void) {
  V82 |= 0x2;
}
static void IVF320_282(void) {
  V82 |= 0x4;
}
static void IVF320_286(void) {
  V83 |= 0x1;
}
static void IVF320_290(void) {
  V83 |= 0x2;
}
static void IVF320_292(void) {
  V83 |= 0x4;
}
static void IVF320_295(void) {
  V84 |= 0x1;
}
static void IVF320_296(void) {
  V84 |= 0x2;
}
static void IVF320_297(void) {
  V84 |= 0x4;
}
static void IVF320_299(void) {
  V30 |= 0x1;
}
static void IVF320_300(void) {
  V30 |= 0x2;
}
static void IVF320_301(void) {
  V30 |= 0x4;
}
#define IVFUNCS
static void (*ivfuncs[320])() = {
  nullfunc,
  IVF32_1,
  IVF320_2,
  IVF32_3,
  IVF320_4,
  nullfunc,
  IVF320_6,
  IVF320_7,
  nullfunc,
  IVF320_9,
  IVF320_10,
  IVF320_11,
  nullfunc,
  IVF320_13,
  IVF320_14,
  IVF320_15,
  nullfunc,
  IVF320_17,
  IVF320_18,
  IVF320_19,
  nullfunc,
  IVF320_21,
  IVF320_22,
  IVF64_23,
  IVF320_24,
  IVF64_25,
  IVF320_26,
  IVF64_27,
  nullfunc,
  IVF64_29,
  IVF320_30,
  IVF64_31,
  nullfunc,
  IVF32_1,
  IVF320_34,
  IVF32_3,
  IVF320_36,
  nullfunc,
  nullfunc,
  IVF320_39,
  IVF320_40,
  IVF320_41,
  nullfunc,
  IVF320_43,
  IVF320_44,
  IVF320_45,
  nullfunc,
  IVF320_47,
  IVF320_48,
  IVF320_49,
  nullfunc,
  IVF320_51,
  IVF320_52,
  IVF320_53,
  IVF320_54,
  IVF64_55,
  nullfunc,
  IVF320_57,
  IVF320_58,
  IVF64_59,
  IVF320_60,
  IVF64_61,
  IVF320_62,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  IVF320_68,
  nullfunc,
  IVF320_70,
  IVF320_71,
  nullfunc,
  IVF320_73,
  IVF320_74,
  IVF320_75,
  nullfunc,
  IVF320_77,
  IVF320_78,
  IVF320_79,
  nullfunc,
  IVF320_81,
  IVF320_82,
  IVF320_83,
  nullfunc,
  IVF64_21,
  IVF320_86,
  IVF64_23,
  IVF320_88,
  IVF64_25,
  IVF320_90,
  IVF64_27,
  nullfunc,
  IVF64_29,
  IVF320_94,
  IVF64_31,
  nullfunc,
  IVF32_1,
  IVF320_98,
  IVF32_3,
  IVF320_100,
  nullfunc,
  nullfunc,
  IVF320_103,
  IVF320_104,
  IVF320_105,
  nullfunc,
  IVF320_107,
  IVF320_108,
  IVF320_109,
  nullfunc,
  IVF320_111,
  IVF320_112,
  IVF320_113,
  nullfunc,
  IVF320_115,
  IVF320_116,
  IVF320_117,
  IVF320_118,
  IVF64_55,
  nullfunc,
  nullfunc,
  IVF320_122,
  IVF64_59,
  IVF320_124,
  IVF64_61,
  IVF320_126,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  IVF320_132,
  nullfunc,
  IVF320_134,
  IVF320_135,
  nullfunc,
  IVF320_137,
  IVF320_138,
  IVF320_139,
  nullfunc,
  IVF320_141,
  IVF320_142,
  IVF320_143,
  nullfunc,
  IVF320_145,
  IVF320_146,
  IVF320_147,
  nullfunc,
  IVF64_21,
  IVF320_150,
  IVF64_23,
  IVF320_152,
  IVF64_25,
  IVF320_154,
  IVF64_27,
  nullfunc,
  IVF64_29,
  nullfunc,
  IVF64_31,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF320_167,
  IVF320_168,
  IVF320_169,
  nullfunc,
  IVF320_171,
  IVF320_172,
  IVF320_173,
  nullfunc,
  IVF320_175,
  IVF320_176,
  IVF320_177,
  nullfunc,
  IVF320_179,
  IVF320_180,
  IVF320_181,
  IVF320_182,
  IVF64_55,
  nullfunc,
  IVF320_185,
  IVF320_186,
  IVF64_59,
  IVF320_188,
  IVF64_61,
  IVF320_190,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  IVF320_196,
  nullfunc,
  IVF320_198,
  IVF320_199,
  nullfunc,
  IVF320_201,
  IVF320_202,
  IVF320_203,
  nullfunc,
  IVF320_205,
  IVF320_206,
  IVF320_207,
  nullfunc,
  IVF320_209,
  IVF320_210,
  IVF320_211,
  nullfunc,
  IVF64_21,
  IVF320_214,
  IVF64_23,
  IVF320_216,
  IVF64_25,
  IVF320_218,
  IVF64_27,
  nullfunc,
  IVF64_29,
  nullfunc,
  IVF64_31,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF320_231,
  IVF320_232,
  IVF320_233,
  nullfunc,
  IVF320_235,
  IVF320_236,
  IVF320_237,
  nullfunc,
  IVF320_239,
  IVF320_240,
  IVF320_241,
  nullfunc,
  IVF320_243,
  IVF320_244,
  IVF320_245,
  IVF320_246,
  IVF64_55,
  nullfunc,
  nullfunc,
  IVF320_250,
  IVF64_59,
  IVF320_252,
  IVF64_61,
  IVF320_254,
  nullfunc,
  nullfunc,
  IVF32_1,
  nullfunc,
  IVF32_3,
  IVF320_260,
  nullfunc,
  IVF320_262,
  IVF320_263,
  nullfunc,
  IVF320_265,
  IVF320_266,
  IVF320_267,
  nullfunc,
  IVF320_269,
  IVF320_270,
  IVF320_271,
  nullfunc,
  IVF320_273,
  IVF320_274,
  IVF320_275,
  nullfunc,
  IVF64_21,
  IVF320_278,
  IVF64_23,
  IVF320_280,
  IVF64_25,
  IVF320_282,
  IVF64_27,
  nullfunc,
  IVF64_29,
  IVF320_286,
  IVF64_31,
  nullfunc,
  IVF32_1,
  IVF320_290,
  IVF32_3,
  IVF320_292,
  nullfunc,
  nullfunc,
  IVF320_295,
  IVF320_296,
  IVF320_297,
  nullfunc,
  IVF320_299,
  IVF320_300,
  IVF320_301,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF64_55,
  nullfunc,
  nullfunc,
  nullfunc,
  IVF64_59,
  nullfunc,
  IVF64_61,
  nullfunc,
  nullfunc
};

static void nullfunc(void){}
#define TRN 320
#define TRD 1
#define LOWLIM (-2880)
#define HIGHLIM (2880)
#define NBROW 37
#define NROWMINF 1
#define NSECSPER 1
#define NROWSPER 32
#define ROLLOVER 65280
#define SYNCHVAL 0xABB4
#define NROWMAJF 320
#define MFSECNUM 32
#define MFSECDEN 1
#define SECDRIFT 90
#define COPY_MFCtr
#define MFCtr home->U0.MFCtr

#ifndef EXTRACTION_INIT
  #define EXTRACTION_INIT
#endif
#ifndef OPT_EXT_INIT
  #define OPT_EXT_INIT
#endif
#ifndef EXTRACTION_TERM
  #define EXTRACTION_TERM
#endif
#ifndef TMINITFUNC
  #define TMINITFUNC
#endif

static unsigned int next_minor_frame, majf_row;
#if (NROWMINF != 1)
  static unsigned int minf_row = 0;
#endif
#ifdef NEED_TIME_FUNCS
  static unsigned short CurMFC;
#endif


void main(int argc, char **argv) {
  oui_init_options(argc, argv);

  TMINITFUNC;
  BEGIN_MSG;
  EXTRACTION_INIT;
  DC_operate();
  EXTRACTION_TERM;
  DONE_MSG;
}


#define MKDCTV(x,y) ((x<<8)|y)
#define DCTV(x,y) MKDCTV(DCT_##x,DCV_##y)

/* The main thing we need to do is reset our row counter on TM START */
void DC_DASCmd(unsigned char type, unsigned char val) {
  switch (MKDCTV(type, val)) {
	case DCTV(TM,TM_START):
	  next_minor_frame = majf_row = 0;
	  #if (NROWMINF != 1)
		minf_row = 0;
	  #endif
	  break;
	case DCTV(TM,TM_END):
	case DCTV(QUIT,QUIT):
	default:
	  break;
  }
}

#define incmod(x,y) if (x==((y)-1)) x = 0; else x++

void DC_data(dbr_data_type *dr_data) {
  unsigned short nrows;

  for (nrows = dr_data->n_rows, home = (void *) &dr_data->data[0];
	   nrows > 0;
	   nrows--, home ++) {

	/* First check the minor frame counter if necessary */
	#if (NROWMINF != 1)
	if (minf_row == 0) {
	#endif
	  COPY_MFCtr /* Needs to be defined by TMC */
	  #ifdef NEED_TIME_FUNCS
		CurMFC = MFCtr;
	  #endif
	  {
		unsigned short delta;
		
		delta = MFCtr - next_minor_frame;
		if (delta != 0) {
		  #ifdef IVFUNCS
			if (delta > NROWMAJF/NROWMINF) delta = NROWMAJF;
			else delta *= NROWMINF;
			/* delta is now the number of rows skipped up to a maximum of
			  nrowmajf. While invalidating, I don't need to update
			  minf_row, since the final will be 0, same as before.
			  MFCtr is already set, and majf_row is updated.
			*/
			while (delta-- > 0)
			  ivfuncs[majf_row]();
		  #endif
		  majf_row = (((unsigned short)MFCtr) % (NROWMAJF/NROWMINF))
							  * NROWMINF;
		}
	  }
	  next_minor_frame = MFCtr+1;
	#if (NROWMINF != 1)
	}
	#endif
	
	/* Now process the row */
	efuncs[majf_row]();
	incmod(majf_row, NROWMAJF);
	#if (NROWMINF != 1)
	  incmod(minf_row, NROWMINF);
	#endif
  }
}

#ifdef __WATCOMC__
  #pragma off (unreferenced)
#endif

void DC_tstamp(tstamp_type *tstamp) { /* Nothing to do! */ }

void DC_other(unsigned char *msg_ptr, int sent_tid) {
  unsigned char rep_msg = DAS_UNKN;

  Reply(sent_tid, &rep_msg, 1);
}

#ifdef __WATCOMC__
  #pragma on (unreferenced)
#endif

#ifdef NEED_TIME_FUNCS
  #if (NROWMINF != 1)
	#define ROWS(x) (((unsigned long)(x))*NROWMINF+minf_row)
  #else
	#define ROWS(x) (x)
  #endif
  #if (NSECSPER != 1)
	#define FRACSECS(x) (((unsigned long)ROWS(x))*NSECSPER)
  #else
	#define FRACSECS(x) ROWS(x)
  #endif
  long itime(void) {
	  return(dbr_info.t_stmp.secs +
		FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double dtime(void) {
	  return(dbr_info.t_stmp.secs +
		(double) FRACSECS(CurMFC-dbr_info.t_stmp.mfc_num)
	#if (NROWSPER != 1)
		  / NROWSPER
	#endif
		  );
  }
  double etime(void) {
	double t;
	static double t0 = -1e9;
	
	t = dtime();
	if (t0 == -1e9) t0 = t;
	return(t - t0);
  }
#endif

dbr_info_type dbr_info = {
  "", /* tmid */
  37, /* NBMINF */
  37, /* NBROW */
  320, /* NROWSMAJF */
  1, /* NSECSPER */
  32, /* NROWSPER */
  0, 1, /* MFC lsb col, msb col */
  0xABB4, /* Synch Value */
  0 /* not inverted */
};
